unit comms;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,crt,dos,misc,globals,synaser, synautil, synafpc ;
type a1 = record
     case boolean of
     false: (ch1:char);
     true: (byte1:byte)
end;
var
a2:a1;
int1:integer;
{Application: aa;}
serial1 : TBlockSerial;
data_Rerceived : byte;

 procedure cursoroff;
  procedure Check_Port(Portname1:string);
 {procedure crc1;}
 procedure cursoron;
 {    procedure fixport;}
 procedure get_data(port:byte);
 procedure Poll_Rx(port,rxident,cmd,params:byte);
 procedure discourse(port, rx,cmd,param:integer);
 function read_input(recno,txno,chno:byte):byte;
 procedure read_cj(recno,txno:byte);
 procedure set_no_tx(recno:byte);
 procedure read_no_tx(recno:byte);
 procedure read_txtype(recno,txno:byte);
 procedure set_txtype(recno,txno:byte);
 procedure read_inptype(recno,txno,chno:byte);
 procedure set_inptype(recno,txno,chno:byte);
 procedure read_alarms(recno,txno,chno:byte);
 procedure set_alarms(recno,txno,chno:byte);
 procedure read_scales(rx,tx,chn:byte);
 procedure set_scales(rx,tx,chn:byte);
 procedure read_datafmt(rx:byte);
 procedure set_datafmt(rx:byte);
 procedure read_temp(recno:byte);
 procedure set_temp(recno:byte);
 procedure read_comms(rx:byte);
 procedure set_comms(rx:byte);
 procedure read_address(rx:byte);
 procedure set_address(rx:byte);
 procedure read_checksum(rx:byte);
 procedure set_csummode(rx:byte);
 procedure read_csummode(rx:byte);
 procedure read_switches(rx:byte);
 procedure read_linerej(rx:byte);
 procedure set_linerej(rx:byte);
 function  read_vals(recno,txno:byte):byte;
 procedure set_tag(recno:byte);
 procedure read_tag(recno:byte);
 procedure send_confirm(rx:byte);
 procedure send_reset(rx,resettype:byte);
 procedure send_signoff(rx:byte);
 procedure initPCcomms(p:byte);
 procedure initcomms;
 procedure init_comport(portName:string);
 procedure init_tx(rx,tx,ttype:byte);
 function unipolar(format:byte):boolean;
 procedure init_scales(rx,txtype:byte);
 procedure read_vers(rx:byte);
 procedure initrx(recno,rectype:byte);
 procedure AuxOut(port1 : byte ; ch : byte);

 {************************************************************************}
implementation
var
    msglength : integer;
    rxmsg     : array[0..512] of byte;
    parray    : array[0..255] of byte;
    commparam : byte;
    timeout   :  boolean;
    crcstat   :  boolean;
    i         :  byte;
    crcres    : word;
    Port_Name:text;

{************************************************************************}
procedure init_comport(portName:string);
begin
serial1.Free;
serial1:=TBlockSerial.Create;
serial1.Connect(portName);
serial1.Config(9600,8,'N',SB1,false,false);
end;


procedure AuxInit(port,params : byte);
begin
end;
{************************************************************************}
function AuxIn(port : word) : byte;
var
a:byte;
begin
a2.byte1:= (serial1.RecvByte(1000));
AuxIn := a2.byte1;
end;

{************************************************************************}
procedure AuxOut(port1 : byte ; ch : byte);
begin
  serial1.SendByte(ch);
 { write(ch);}
end;
{************************************************************************}
function AuxInReady(port : word) : boolean;
   begin
   end;

{************************************************************************}
function AndByte(data, mask : byte) : byte;
begin
  Andbyte:=(data and mask);
end;

{************************************************************************}
function OrByte(data, mask : byte) : byte;
    begin
      OrByte:= (data and mask);
    end;

{************************************************************************}
function TstBit(data, bit : byte) : boolean;
var
temp1,temp2:byte;
    begin
       temp1:=$01;
       temp1:= (temp1 << bit);
       temp1:=(data and temp1);
       if temp1=0 then
          begin
            TstBit:= false
            end
       else
       begin
       TstBit:= true
          end;

    end;

{************************************************************************}
function SetBit(data,bit : byte) : byte;
    begin

    end;

{************************************************************************}
function ClrBit(data, bit : byte) : byte;
begin

end;


{************************************************************************}
procedure Poll_Rx(port,rxident,cmd,params:byte);
          var i : byte;
              temp:boolean;
              txmsg:array[0..10] of byte;
              b,c:longint;
              txlimit:integer;

          begin
	    timeout:=false;
	    breakout:=false;
            txlimit:=200; {timeout limit on Tx message in 50mS intervals}
	    for i:=0 to 10 do rxmsg[i]:=0;
	    txmsg[0]:=$02;
	    txmsg[1]:=$02;
	    txmsg[2]:=$63;
	    txmsg[3]:=rxident+$50;
	    txmsg[4]:=cmd+$30;
            b:=tic;
	    for i:=0 to 4 do
		begin
		     auxout(port,txmsg[i]);
		     timeout:=(timetest(b,txlimit) or timeout);
		     if (IsEscape) then breakout:=true;
		     if (breakout or timeout) then exit;
		end;
	    if params>0 then for i:=0 to (params-1) do
		begin
		auxout(port,parray[i]);
			timeout:=(timetest(b,txlimit) or timeout);
			if (IsEscape) then breakout:=true;
			if (breakout or timeout) then exit;
		end;
	    auxout(port,03);
	  end; {Poll_Rx}
  procedure Check_Port(Portname1:string);
begin
  gotoxy(1,Column_Number);
  Write('Checking MTL838 Receiver at: ');
  Write(Portname1);
  write('...');
init_comport(Portname1);
      auxout(port,$02);
      auxout(port,$02);
      auxout(port,$63);
      auxout(port,$50);
      auxout(port,$41);
      auxout(port,$03);
      get_data(port);

if msglength <6  then
   begin
   Port_Selection:=false;
   end
   else
   begin
   selected_port_name := Portname1;
   Port_Selection:=true;
   end;
   init_comport(selected_port_name);
{   readln;}
Column_Number:= Column_Number+1;
end;
{************************************************************************}
procedure get_data(port:byte);

         var tlimit1,tlimit2:integer;
             b,c:longint;
             loop:integer;
             x: byte;

         begin
         loop :=0;
         c:=0;
         repeat
         c:=c+1;
             x:= AuxIn(1);
              rxmsg[loop]:= x;

                  if (c > 4) or (Isescape) then
     begin
     gotoxy(1,25);
     breakout:=true;
     timeout:=true;
     exit;
     end;
         until x = $02;
          loop := succ(loop);
          c:=0;
{          write(x);}
     repeat
      c:= c+1;
     x:= AuxIn(1);
  {   write(x);
      write('-');}
     rxmsg[loop]:= x;

    {       write(loop);
           write(':');  }
     loop := succ(loop);

     if (c > 511) or (Isescape) then
     begin
     gotoxy(1,25);
     write('Write Error               ');
     breakout:=true;
     timeout:=true;
     exit;
     end;

      until x=$03;
      msglength:= loop-1;
   {         write('=');
                  write(msglength);}

      end;


{************************************************************************}
function RxMsgOk(rxident:byte):boolean;
         var ok : boolean;
             i : byte;
         begin
           ok:=true;
           if timeout then ok:=false;
           if (rxmsg[0]<>02) then ok:=false;
           if (rxmsg[3]<>$62) then ok:=false;
           if (rxmsg[4]<>$50+rxident) then ok:=false;
           RxMsgOk:=ok;
         end;


{************************************************************************}

function HighwayOk(highway:byte):boolean;
         begin
           case highway of
                1 : HighwayOk:=TstBit(rxmsg[1],2);
                2 : HighwayOk:=TstBit(rxmsg[1],1);
           else HighwayOk:=false;
           end;
         end;

{************************************************************************}
function Broadcast:boolean;
         begin
           if TstBit(rxmsg[1],3) then Broadcast:=true
                                 else Broadcast:=false;
         end;

{************************************************************************}
function Han83:boolean;
         begin
           if TstBit(rxmsg[2],2) then Han83:=true
                                 else Han83:=false;
         end;

{************************************************************************}
function ELDinput:boolean;
         begin
           if not TstBit(rxmsg[1],0) then ELDinput:=true
                                     else ELDinput:=false;
         end;

{************************************************************************}
function SysFail:boolean;
         begin
           if (not HighwayOk(1)) and (not HighwayOk(2)) then
              SysFail:=true else SysFail:=false;
         end;

{************************************************************************}
procedure SetBaudRate(port:byte;rate:integer);
          var mask : byte;
          begin
            case rate of
                1     :  mask:=$40;
                2     :  mask:=$60;
                3     :  mask:=$80;
                4     :  mask:=$A0;
                5     :  mask:=$C0;
                6     :  mask:=$E0;
              else mask:=$E0;
            end;
            commparam:=AndByte(commparam,$1F);
            commparam:=OrByte(commparam,mask);
            auxinit(port,commparam);
          end;

{************************************************************************}
procedure SetParity(port:byte;parity:byte);
          begin
            if (parity=0) then commparam:=ClrBit(commparam,3)
              else
                begin
                  commparam:=SetBit(commparam,3);
                  if (parity=2) then commparam:=SetBit(commparam,4)
                                else commparam:=ClrBit(commparam,4);
                end;
            auxinit(port,commparam);
          end;

{************************************************************************}
procedure SetDataBits(port,number:byte);
          var mask : byte;
          begin
            case number of
              7 : mask:=2;
              8 : mask:=3;
            else mask:=3;
            end;
            commparam:=AndByte(commparam,$FC);
            commparam:=OrByte(commparam,mask);
            auxinit(port,commparam);
          end;

{************************************************************************}
procedure SetStopBits(port,number:byte);
          begin
            if number=2 then commparam:=SetBit(commparam,2)
                        else commparam:=ClrBit(commparam,2);
            auxinit(port,commparam);
          end;
{************************************************************************}

{{$Link 'crcv30.o'}
procedure crc; external;}
{procedure crc1;
begin

end;}
{************************************************************************}


function crcerror:boolean;

var
   crcerr:word;

begin

if msglength>6 then
   begin
{   crc;}
   crcerr:=crcres;
   if crcerr=0 then
      crcerror:=false
   else
      begin
      crcerror:=true;
      end;
   end
else
   crcerror:=true;

end;

{***************************************************************************}
procedure discourse(port, rx,cmd,param:integer);

{this procedure sends a message and checks the response}
var
   i,tries:integer;
   a,b,c:boolean;
   t:char;
begin
tries:=0;
if not msgerror then
repeat
      begin
              init_comport(selected_port_name);
      poll_rx(port,rx,cmd,param);
      if not(timeout or breakout) then
         get_data(port);
{      readln;}
      if not(timeout or breakout) then
        begin
        receiver[rx]^.status1:=rxmsg[1];
        receiver[rx]^.status2:=rxmsg[2];
        a:=not(rxmsgok(rx));
        b:=tstbit(rxmsg[2],3);
        c:=crcerror;
        oldvals:=tstbit(rxmsg[2],1);
        if oldvals then errmsg:=' Tx Failed';
        msgerror:= (a or b or c);
        if a then errmsg:=' Invalid Response';
        if c then errmsg:=' CRC Error';
        if b then  case rxmsg[7]-$30 of
            0:errmsg:=' Protocol Error';
            1:errmsg:=' Wrong Parameters';
            2:errmsg:=' Tx/Ch Invalid';
            3:errmsg:=' Param Overange';
            4:errmsg:=' Tx Error';
            5:errmsg:=' Context Error';
            6:errmsg:=' Unknown Error';
            7:errmsg:=' Write Disabled';
            end;
        hht:=han83;
        end
      else
        begin
        msgerror:=true;
        if breakout then
                       errmsg:='  ABORTED   '
                    else
                        errmsg:=' RS232 Timeout';
        end;

      inc(tries);
      end;
until (timeout or breakout or (msgerror and (tries=2))or (not msgerror));


end;

{***************************************************************************}
procedure enquire(recno,cmd,param,nofield:integer;var a:real; var b:real);

var
   tries,errcode,i,q,count,point:integer;
   num:string[20];
   x:real;
   again:boolean;
   y:char;


begin
tries:=0;
repeat
      begin
      again:=false;
      if not msgerror then
         begin
         inc(tries);
         discourse(port,recno,cmd,param);
         if breakout then exit;
         if not(msgerror) then
             begin
             {decode the message}
             point:=0;
             repeat
                   inc(point)
             until rxmsg[point]=13;

             if param>0 then
                   repeat
                       inc(point)
                   until rxmsg[point]=13;
             inc(point);
             {Start of data fields}
             for i:=1 to nofield do
                  begin

                  while rxmsg[point] in[13,10,32,72,76,82] do inc(point);
                  count:=1;
                  while (rxmsg[point] in[43,45,46,48..63,69,101]) do
                             if rxmsg[point] in [58..63] then
                                 begin       {control code that is not an ascii number}
                                 num:=copy(num,1,(count-1))+'1'+chr(rxmsg[point]-10);
                                 inc(point);
                                 count:=count+2;
                                 end
                             else
                                 begin      {ascii number}
                                 num:=copy(num,1,(count-1))+chr(rxmsg[point]);
                                 inc(point);
                                 inc(count);
                                 end;

                  val(copy(num,1,(count-1)),x,errcode);
                  if errcode=0 then
                          case i of
                               1:a:=x;
                               2:b:=x;
                          end
                  else
                          begin
                          again:=true;
                          if tries=2 then
                             begin
                             msgerror:=true;
                             errmsg:=' Data Error';
                             end;
                          end;
                  end;

             end

      end;
end;
until ((again=false) or ( msgerror));
end;

{***************************************************************************}
function iostr(x:real):string;
var
   y:string;

begin
     str(x:10:3,y);
     iostr:=y

end;

{****************************************************************************}
function num(x:real):byte;

begin
num:=trunc(x+0.5);
end;
{***************************************************************************}
procedure cursoroff;
{
var
   reg:registers;
 }
begin
{
reg.ah:=8;

intr($10,reg);
reg.ah:=3;
intr($10,reg);
reg.ah:=1;
reg.ch:=(reg.ch) or ($20);
intr($10,reg);}
end;
{***************************************************************************}
procedure cursoron;
{
var
   reg:registers;}

begin
{reg.ah:=8;
intr($10,reg);
reg.ah:=3;
intr($10,reg);
reg.ah:=1;
reg.ch:=((reg.ch) and not($20));
intr($10,reg);}
end;
{***************************************************************************}
function read_input(recno,txno,chno:byte):byte;

var
   dum2:real;
   l,i:integer;
   mtype:integer;

begin
     with receiver[recno]^ do
       with transmitter[txno] do
        with channel[chno] do
          begin
          parray[0]:=txno+$30;
          parray[1]:= chno+$30;
          discourse(port,recno,1,2);

          mtype:=rxmsg[7]-48;  { 1 for MTL831 or 2 for MTL832 }
          if mtype<>2 then mtype:=1; { default to  MTL831 if unknown}

          if not msgerror then
             begin
             if hht then delay(500); {if han83 fitted}
             value:='';
             for i:=13 to msglength-9 do
               if chr(rxmsg[i]) in[' ','0'..'9','.','+','-','A'..'Z'] then
                 value:=value+chr(rxmsg[i])
               else
                 begin
                 msgerror:=true;
                 errmsg:=' Data Error';
                 end;


             l:=length(value);

             while l<11 do
                    begin
                    value:=' '+value;
                    inc(l);
                    end;

             case rxmsg[11] of
                  76:alarm:=low;
                  72:alarm:=high;
                  else alarm:= off;
                  end;

             case rxmsg[msglength-7] of
               $21:vunit:=chr(251)+'I';
               $43:vunit:=chr(248)+'C';
               $46:vunit:=chr(248)+'F';
               $49:vunit:='mA';
               $4B:vunit:=' K';
               $52:vunit:=' '+chr(234);
               else vunit:='  ';
               end;
             end;

          hw1:=highwayok(1);
          hw2:=highwayok(2);
          end;

read_input:=mtype;
end;

{***************************************************************************}
procedure read_cj(recno,txno:byte);

var
   l:integer;

begin
     with receiver[recno]^ do
       with transmitter[txno] do
          begin
          parray[0]:=txno+$30;
          discourse(port,recno,2,1);
          if not msgerror then
             begin
             cjtemp:='';
             for i:=10 to msglength-9 do
               if chr(rxmsg[i]) in[' ','0'..'9','.','+','-','A'..'Z'] then
                 cjtemp:=cjtemp+chr(rxmsg[i])
               else
                 begin
                 msgerror:=true;
                 errmsg:=' Data Error';
                 end;

             l:=length(cjtemp);

             while l<11 do
                    begin
                    cjtemp:=' '+cjtemp;
                    inc(l);
                    end;

             case rxmsg[msglength-7] of
               $21:cjunit:=chr(251)+'I';
               $43:cjunit:=chr(248)+'C';
               $46:cjunit:=chr(248)+'F';
               $49:cjunit:='mA';
               $4B:cjunit:=' K';
               $52:cjunit:=' '+chr(234);
               else cjunit:='  ';
               end;
             end;
          end

end;

{***************************************************************************}
procedure read_no_tx(recno:byte);


begin
     with receiver[recno]^ do
          begin
          discourse(port,recno,4,0);
          if not msgerror then
             no_of_tx:=rxmsg[7]-$30;
          if not(no_of_tx  in [1..4]) then no_of_tx:=1
          end

end;

{***************************************************************************}
procedure set_no_tx(recno:byte);

begin

with receiver[recno]^ do
     begin
     parray[0]:=no_of_tx+$30;
     discourse(port,recno,4,1);
     end;

end;

{**************************************************************************}
procedure read_txtype(recno,txno:byte);


begin
     with receiver[recno]^ do
       with transmitter[txno] do
          begin
          parray[0]:=txno+$30;
          discourse(port,recno,5,1);
          if not msgerror then
             txtype:=rxmsg[10]-$30;
          if not(txtype in[1..2]) then txtype:=1;
          end

end;

{***************************************************************************}
procedure set_txtype(recno,txno:byte);

begin

with receiver[recno]^ do
 with transmitter[txno] do

     begin
     parray[0]:=txno+$30;
     parray[1]:=txtype+$30;
     discourse(port,recno,5,2);
     end;

end;

{**************************************************************************}
procedure read_inptype(recno,txno,chno:byte);


begin
     with receiver[recno]^ do
       with transmitter[txno] do
        with channel[chno] do
          begin
          parray[0]:=txno+$30;
          parray[1]:= chno+$30;
          discourse(port,recno,6,2);
          if not msgerror then
             begin
             input_type:=rxmsg[11]-$30;
             thc_drive:=rxmsg[14]-$30;
             end;
          if not(input_type+(txtype-1)*10 in[0..15,18,19]) then input_type:=0;
          if not(thc_drive in[0..2]) then thc_drive:=0;
          end

end;

{***************************************************************************}
procedure set_inptype(recno,txno,chno:byte);

begin

with receiver[recno]^ do
 with transmitter[txno] do
  with channel[chno] do

     begin
     parray[0]:=txno+$30;
     parray[1]:=chno+$30;
     parray[2]:=input_type+$30;
     parray[3]:=thc_drive+$30;
     discourse(port,recno,6,4);
     end;

end;

{**************************************************************************}
procedure read_alarms(recno,txno,chno:byte);


begin
     with receiver[recno]^ do
       with transmitter[txno] do
        with channel[chno] do
          begin
          parray[0]:=txno+$30;
          parray[1]:=chno+$30;
          enquire(recno,8,2,2,low_alarm,high_alarm);
          if breakout then
                      begin
                       msgerror:=true;
                       errmsg:='  ABORTED   ';
                      end;

          end

end;

{***************************************************************************}
procedure set_alarms(recno,txno,chno:byte);

var
   text1,text2:string[10];
   i:integer;

begin

with receiver[recno]^ do
 with transmitter[txno] do
  with channel[chno] do

     begin
     parray[0]:=txno+$30;
     parray[1]:=chno+$30;
     text1:=iostr(low_alarm);
     text2:=iostr(high_alarm);
     for i:=2 to 11 do
         parray[i]:=ord(text1[i-1]);

     parray[12]:=$0D;
     for i:=13 to 22 do
         parray[i]:=ord(text2[i-12]);

     parray[23]:=$0D;
     discourse(port,recno,8,24);
     end;

end;

{**************************************************************************}
procedure getparameter(var count:byte; var number:real);
{used to extract a scaling parameter from rxmsg}

var  temp:string;
     code:integer;

begin
temp:='';
{find first number}
while not(rxmsg[count] in[46,48..59]) do inc(count);
{read in parameter}
while rxmsg[count] in[46,48..59] do
                begin
                   temp:=temp+chr(rxmsg[count]);
                   inc(count);
                end;
      val(temp,number,code);
end;
{**************************************************************************}
procedure read_scales(rx,tx,chn:byte);
{ procedure to read the three scaling parameters, scale_ipzero, scale_opzero}
{ and scale_gain from the MTL838 }
var
   count:byte;
   temp:real;



begin
count:=0;
with receiver[rx]^ do
 with transmitter[tx] do
  with channel[chn] do
          begin
          parray[0]:=tx+$30;
          parray[1]:=chn+$30;
          discourse(port,rx,35,2);
          if not msgerror then
           begin
             count:=head+5;  {skip to start of input zero }
             getparameter(count,temp);  {get input zero}
             scale_ipzero:=temp;
             getparameter(count,temp);  {get gain}
             scale_gain:=temp;
             getparameter(count,temp);  {get output zero}
             scale_opzero:=temp;
           end;
       end; {with channel}
end; {read_scales}
{**************************************************************************}
procedure  set_scales(rx,tx,chn:byte);
{ procedure to write the three scaling parameters, scale_ipzero, scale_opzero}
{ and scale_gain to the MTL838 }
var text:string[10];

begin

with receiver[rx]^ do
 with transmitter[tx] do
  with channel[chn] do
     begin
     parray[0]:=tx+$30;
     parray[1]:=chn+$30;
     text:=iostr(scale_ipzero);


     for i:=2 to 11 do
         parray[i]:=ord(text[i-1]);

     parray[12]:=$0D;
     parray[13]:=$0A;
     text:=iostr(scale_gain);
     for i:=14 to 23 do
         parray[i]:=ord(text[i-13]);

     parray[24]:=$0D;
     parray[25]:=$0A;

     text:=iostr(scale_opzero);
     for i:=26 to 35 do
         parray[i]:=ord(text[i-25]);

     parray[36]:=$0D;
     parray[37]:=$0A;

     discourse(port,rx,35,37);
     end;
end;
{**************************************************************************}
procedure read_datafmt(rx:byte);    {rx:byte}


begin
     with receiver[rx]^ do
          begin
          discourse(port,rx,29,0);
          if not msgerror then
          data_format:=rxmsg[head+3]-$30;
          end

end;

{***************************************************************************}
procedure set_datafmt(rx:byte); {rx:byte}

begin

with receiver[rx]^ do
     begin
     { use command 29 to set data format }
     parray[0]:=data_format+$30;
     discourse(port,rx,29,1);
     end;

end;

{**************************************************************************}
procedure read_vers(rx:byte);   {rx:byte}


begin
     with receiver[rx]^ do
          begin
          discourse(port,rx,33,0);
          if not msgerror then
         { write('=');}
             ipver:='          ';
             hcaver:='          ';
             for i:=1 to 4 do
                 begin
                      ipver[i+3]:=chr(rxmsg[head+2+i]);
                     { write(rxmsg[head+2+i]);}
                      hcaver[i+3]:=chr(rxmsg[head+8+i]);
                     { write(rxmsg[head+8+i]);  }
                 end;
          end

end;


{**************************************************************************}
procedure read_temp(recno:byte);


begin
     with receiver[recno]^ do
          begin
          discourse(port,recno,11,0);
          if not msgerror then
           { write(rxmsg[7]-48);}
             units:=(rxmsg[7]-48);

	  if not(units in[1..3]) then units:=1;
          end

end;

{***************************************************************************}
procedure set_temp(recno:byte);

begin

with receiver[recno]^ do
     begin
     parray[0]:=units+$30;
     discourse(port,recno,11,1);
     end;

end;

{**************************************************************************}
procedure read_comms(rx:byte); {rx:byte}

var
   temp,offset:byte;

begin
with receiver[rx]^ do
     begin
     { command 31 with no parameters }
     discourse(port,rx,31,0);
     if not msgerror then
        begin
             if (rxmsg[head+3]=ord('H'))
                                then
                                    begin
                                        {hardware comms}
                                        comm_mode:=false;
                                        offset:=0;
                                    end
                                else
                                    begin
                                      {software comms}
                                      comm_mode:=true;
                                      offset:=4;
                                    end;
             if (rxmsg[head+6+offset]-$30 in[1..8])
                then mod_baud:=rxmsg[head+offset+6]-$30
                else mod_baud:=6;
             temp:=rxmsg[head+offset+7];
             if ((temp and 1)<>0) then mod_stop:=2 else mod_stop:=1;
             if ((temp and 4)<>0) then mod_dbits:=1 else mod_dbits:=0;
             if ((temp and 2)=0)
                       then
                           mod_parity:=0 { no parity }
                       else
                           if ((temp and 8)<>0)
                               then mod_parity:=1 {odd parity}
                               else mod_parity:=2; {even parity}

        end; { if not msgerror }

     end;
end;

{*************************************************************************}
procedure set_comms(rx:byte); {rx:byte}


var temp:byte;

begin

with receiver[rx]^ do

     begin
     temp:=0;
     if mod_stop=2 then temp:=temp or 1;
     if mod_parity<>0 then temp:=temp or 2;
     if mod_parity=1 then temp:=temp or 8;
     if mod_dbits=1 then temp:=temp or 4;

     parray[0]:=$30+mod_baud;
     parray[1]:=$30+temp;

     discourse(port,rx,31,2);
     end;


end;
{****************************************************************************}
procedure read_address(rx:byte); {rx:byte}

var
   temp,offset:byte;

begin
with receiver[rx]^ do
     begin
     { command 32 with no parameters }
     discourse(port,rx,32,0);
     if not msgerror then
        begin
             if (rxmsg[head+3]=ord('H'))
                                then
                                    begin
                                        {hardware comms}
                                        add_mode:=false;
                                        offset:=0;
                                    end
                                else
                                    begin
                                      {software comms}
                                      add_mode:=true;
                                      offset:=6;
                                    end;

             mod_addressA:=(rxmsg[head+6+offset]-$30)*16
                           +(rxmsg[head+7+offset]-$30);
             mod_addressB:=(rxmsg[head+8+offset]-$30)*16
                           +(rxmsg[head+9+offset]-$30);

        end; { if not msgerror }

     end;
end;
{*************************************************************************}
procedure set_address(rx:byte); {rx:byte}

begin

with receiver[rx]^ do

     begin
          parray[0]:=$30+((mod_addressA and $F0) div 16);
          parray[1]:=$30+(mod_addressA and $0F);
          parray[2]:=$30+((mod_addressB and $F0) div 16);
          parray[3]:=$30+(mod_addressB and $0F);

     discourse(port,rx,32,4);
     end;


end;
{****************************************************************************}
procedure read_checksum(rx:byte);   {rx:byte}

var mult:longint;
    i:integer;

begin
with receiver[rx]^ do
  begin
{     checksum:=0;
     ramchksum:=0;       }
    { command 34 with no parameters }
    discourse(port,rx,34,0);
{    if not msgerror then     }
        begin
            mult:=1;
	    for i:=5 downto 0 do
	      begin
{		checksum:=checksum+(rxmsg[head+i+3] and $3f)*mult;
                ramchksum:=ramchksum+(rxmsg[head+i+9] and $3f)*mult;
                mult:=mult*64;   }
	      end; {for i}
        end; {if not msgerror}
    end; {with receiver}
end;
{****************************************************************************}
procedure set_csummode(rx:byte); {rx:byte}
{command 30}
begin

with receiver[rx]^ do
     begin
     parray[0]:=check_mode+$30;
     discourse(port,rx,30,1);
     end;

end;
{****************************************************************************}
procedure read_csummode(rx:byte); {rx:byte}
{ read the checksum mode parameter }

var
   temp,offset:byte;

begin
with receiver[rx]^ do
     begin
       { command 30 with no parameters }

       discourse(port,rx,30,0);
       if not msgerror then
	    check_mode:=rxmsg[head+3]-$30;


     end;
end;

{*************************************************************************}
procedure read_switches(rx:byte); {rx:byte}


begin
with receiver[rx]^ do
     begin

       { command 36 with no parameters }
       discourse(port,rx,36,0);
       if not msgerror then
	  begin
             ipswitch:=(rxmsg[head+3]-$30)*16
                           +(rxmsg[head+4]-$30);
             hcaswitch:=(rxmsg[head+5]-$30)*16
                           +(rxmsg[head+6]-$30);

	  if (hcaswitch and $40)=0 then
		  mod_mode:=1  {RTU mode}
		  else
		  mod_mode:=0;  {ASCII mode}
	  end; { if not msgerror }

     end;
end;


{*****************************************************************************}
procedure read_linerej(rx:byte);


begin
     with receiver[rx]^ do
	  begin
	    discourse(port,rx,15,0);
	    if not msgerror then
	       line_rej:=rxmsg[7]-$30;
{	    if not(line_rej in[0..1]) then line_rej:=1;}
	  end

end;

{***************************************************************************}
procedure set_linerej(rx:byte);

begin

with receiver[rx]^ do
     begin
       parray[0]:=line_rej+$30;
       discourse(port,recno,15,1);
     end;

end;

{**************************************************************************}
function read_vals(recno,txno:byte):byte;

var
   l,i,point,errcode:integer;
   dummy:real;
   dat:string[30];
   mtype:integer;
   num_channels:byte;

begin
with receiver[recno]^ do
with transmitter[txno] do
     begin
     msgerror:=false;
     parray[0]:=txno+$30;
     discourse(port,recno,16,1);
{      write(msgerror);
     readln; }
     point:=11;
     if hht then delay(100);  { if han83 fitted }
     mtype:=rxmsg[8]-48;  { mtype= 1 for MTL831 or 2 for MTL832 }

     if mtype<>2 then mtype:=1;{default to MTL831 for unknown transmitter}
     num_channels:=8*(3-mtype);
     if not msgerror then
         for i:=1 to num_channels do
         with channel[i] do
              begin
              case rxmsg[point] of
                   76:alarm:=low;
                   72:alarm:=high;
                   else alarm:=off;
                   end;


              inc(point);

              while rxmsg[point]=32 do inc(point);
              value:='';
              while (rxmsg[point]<>32) and (not msgerror) do
                   if (chr(rxmsg[point]) in['0'..'9','.','+','-','A'..'Z']) and (point<500) then
                      begin
                      value:=value+chr(rxmsg[point]);
                      inc(point);
                      end
                   else
                     begin
                     msgerror:=true;
                     errmsg:=' Data Error';
                     end;
              l:=length(value);

              while l<11 do
                    begin
                    value:=' '+value;
                    inc(l);
                    end;

              inc(point);
              case rxmsg[point] of

               $21:vunit:=chr(251)+'I';
               $43:vunit:=chr(248)+'C';
               $46:vunit:=chr(248)+'F';
               $49:vunit:='mA';
               $52:vunit:=' '+chr(234);
               else vunit:='  ';
               end;

              while (rxmsg[point]<> 10) and not msgerror do inc(point);
              inc(point);
              end;

     hw1:=highwayok(1);
     hw2:=highwayok(2);
     ELD:=eldinput;

     end;

read_vals:=mtype;  { read_vals = 1 for MTL831 or 2 for MTL832 }

end;
{***************************************************************************}
procedure set_tag(recno:byte);

var
   i:integer;

begin
with receiver[recno]^ do
     begin
     for i:=0 to 24 do
         parray[i]:=ord(tag_field[i+1]);

     discourse(port,recno,17,25);
     end;

end;
{ procedure fixport;
 begin

 end;
 }
{************************************************************************}
procedure read_tag(recno:byte);

var
   i:integer;

begin
  {
       with receiver[recno]^ do
       with transmitter[txno] do
        with channel[chno] do
          begin }
with receiver[recno]^ do

     begin
     discourse(port,recno,17,0);
     with receiver[recno]^ do
     tag_field := '';
     if not msgerror then
        begin
       tag_field:='';
        for i:=1 to 25 do
          begin
            if (rxmsg[i+6] in[32..122])
               then
                  tag_field:=tag_field+chr(rxmsg[i+6])
               else
                  tag_field:=tag_field+chr(32);
          end;

	end;
     end;

end;


{***************************************************************************}

function unipolar(format:byte):boolean;

begin
     if format in[4,8,12,16] then unipolar:=true
                             else unipolar:=false;
end; {unipolar}
{***************************************************************************}
procedure init_tx(rx,tx,ttype:byte);

var
   k:byte;
   halarm,lalarm,ipzero,opzero,gain:integer;

begin

with receiver[rx]^ do
   with transmitter[tx] do
    begin
        txtype:=ttype;
        case ttype of
           1: begin
                 halarm:=60;
                 ipzero:=0;
                 opzero:=0;
                 gain:=1;
                 if unipolar(receiver[rx]^.data_format) then
                             lalarm:=0
                          else
                             lalarm:=-60;
              end;
           2: begin
                 halarm:=20;
                 lalarm:=4;
                 ipzero:=0;
                 opzero:=0;
                 gain:=1;
             end;
           end; {case}

        cjtemp:='';
	for k:=1 to 16 do
           with channel[k] do
                 begin
                    value:='';
                    vunit:='  ';
                    high_alarm:=halarm;
                    low_alarm:=lalarm;
                    alarm:=off;
                    input_type:=0;
                    thc_drive:=0;
		    scale_ipzero:=ipzero;
		    scale_opzero:=opzero;
		    scale_gain:=gain;
                 end; {with channel}
    end; {with transmitter}

end; {procedure init_tx}

{***************************************************************************}

procedure init_scales(rx,txtype:byte);

var       j:byte;

begin
for j:=1 to 4 do
                init_tx(rx,j,txtype);
end; {procedure init_scales}
{**************************************************************************}
procedure initrx(recno,rectype:byte);

var
   j:byte;

begin

with receiver[recno]^ do
      begin
        hw1:=false;
        hw2:=false;
	mod_mode:=2; {RTU/ASCII mode set to undefined}
        eld:=false;
        tag_field:='Data not loaded              ';
	ipver:='Unknown';
	hcaver:='Unknown';
	comm_mode:=true;
	add_mode:=true;
	data_format:=0;
	mod_addressA:=0;
	mod_addressB:=0;
	check_mode:=0;
	mod_baud:=6;  {6=9600 baud}
	mod_parity:=0; {0=no parity}
	mod_stop:=1;  {1 stop bit}
	mod_dbits:=1; {1=8 data bits}
	checksum:=0;
        ramchksum:=0;
        cksum_base:=1;
	units:=1;
	line_rej:=0;
        no_of_tx:=1;
	for j:=1 to 4 do
                init_tx(recno,j,rectype);
      end; {with receiver}

end;
{**************************************************************************}
procedure send_confirm(rx:byte); {rx:byte}
{ sends a command to the MTL838 to clear the BADPUP / Corruption flag }


begin
   parray[0]:=$30;
   discourse(port,rx,25,1);
end;


{**************************************************************************}
procedure send_reset(rx,resettype:byte); {rx,resettype}

{ supports four types of reset selected by resettype }
{ 1 = MTL831 factory defaults }
{ 2 = MTL832 factory defaults }
{ n.b. 3..8 not allowed }
{ 9 = MTL831 default scalings }
{ A = MTL832 default scalings }


begin
   parray[0]:=resettype+$30;
   discourse(port,rx,26,1);
end;

{**************************************************************************}
procedure send_signoff(rx:byte); {rx:byte}
{ note the signoff command forces a reset within the MTL838 }
begin
     poll_rx(port,rx,28,0)
end; {send_signoff}
{**************************************************************************}
procedure initPCcomms(p:byte); {p:byte}
{initialise the PC comm port for communication with the MTL838}
begin

    {InitSerialPort(port);}
end;
{***************************************************************************}

procedure initcomms;
{initialisation routine called by MTLMUX}

var
   ch:char;
   h,m,olds,s100,news,n100:word;
   j:longint;
   clk:real;

begin

{interrupt tic}
Tic:=TROLLOVER;
tictimeout:=false;

oldvals:=false;
hht:=false;
if  (paramstr(1)='BW') or (paramstr(1)='bw') then
   begin
   back:=black;
   bartext:=black;
   errbar:=black;
   menu:=black;
   graphback:=black;
   normfill:=black;
   alarmfill:=white;
   menutext:=white;
   maintext:=yellow;
   end
else
   begin
   back:=blue;
   bartext:=red;
   errbar:=red;
   menu:=magenta;
   graphback:=blue;
   normfill:=lightblue;
   alarmfill:=red;
   menutext:=white;
   maintext:=white;
   end;



with globdat do
     begin
     getdir(0,path);
     name:=path;
     filename:='';
     {initilise IBM comms}
     {uses either COM1 or COM2}
     {but fixed at 9600, no parity}
     {8 data bits, 1 stop bit}
{     port:=0;}
      port:=1;
     initPCcomms(port);
     msgerror:=false;
     errmsg:='';
     recno:=0;
     txno:=1;
     chno:=1;
     hht:=false;
     {setup variables}

     { initialise receiver }

     new(&receiver[0]);
     initrx(0,1);
     receiver_present[0]:=false;

     rxconfig[0]:=true;
     end;


end;
end.

