unit demo;

{Based on PCS83 Barry Ensten 22/2/89}
{MODBUS version 4.0 Andrew Simpson 21/12/93}
{ this unit contains routines for monitoring inputs or transmitters }
interface

uses crt,graph,wind,comms,scrn,wind2,misc,globals,hardc;

procedure textdemo;
procedure moninput;

{**************************************************************************}
implementation

procedure monip;
var
   i:integer;
   done:boolean;
   ch,x:char;
   txvalstype:byte;


begin
done:=false;
repeat
     msgerror:=false;
     window(1,1,80,25);
     textbackground(black);
     gotoxy(1,25);
     write(message[53]);
     read_cj(recno,txno);
     if not msgerror then txvalstype:=read_input(recno,txno,chno);
     if breakout then done:=true;
     gotoxy(1,25);
     write('                   ');
     textbackground(back);
     if not msgerror then
     with receiver[recno]^.transmitter[txno].channel[chno] do
              begin
              gotoxy(61,8);
              write(value,' ');
              gotoxy(65,10);
              case alarm of
                   off:write('        ');

                   high:begin
                        write(' ');
                        textbackground(errbar);
                        write(message[43]+' ');
                        textbackground(back);
                        end;

                    low:begin
                        write(' ');
                        textbackground(errbar);
                        write(message[44]+' ');
                        textbackground(back);
                        end;
                     end;
               gotoxy(61,12);

               if txvalstype=1
                    then
                       write(receiver[recno]^.transmitter[txno].cjtemp
                       ,' ',receiver[recno]^.transmitter[txno].cjunit)
                    else
                      write('      N/A');
               gotoxy(65,14);
               case receiver[recno]^.hw1 of
                    true:write(message[45]+'    ');
                    false:begin
                          textbackground(errbar);
                          write(message[46]+' ');
                          textbackground(back);
                          end;
                    end;
               gotoxy(65,16);
               case receiver[recno]^.hw2 of
                    true:write(message[45]+'    ');
                    false:begin
                          textbackground(errbar);
                          write(message[46]+' ');
                          textbackground(back);
                          end;
                    end;
               end;
               gotoxy(60,18);
               if not msgerror then write(message[56+ord(hht)]);
               gotoxy(5,23);
               write('                           ');
               gotoxy(80,25);
               if  (msgerror or oldvals) and not(done)  then
                   begin
                   gotoxy(5,23);
                   textbackground(errbar);
                   write(errmsg);
                   textbackground(back);
                   gotoxy(80,25);
                   write(^g);
                   delay(5000);
                   end;
until done;
end;
{***************************************************************************}
procedure moninput;

var
     oldx,oldy,i,temptype : byte;

begin
escape:=false;
oldx:=xcur;
oldy:=ycur;
xcur:=1;
ycur:=1;
repeat
  if receiver[recno]^.transmitter[txno].txtype=1
          then  rtd:=IsRtd(recno,txno)
          else  rtd:=false;
  with receiver[recno]^.transmitter[txno] do
   with channel[chno] do
      begin
      backgnd(0);

      disp[1,1]:='     '+stg(txno,2);
      disp[1,2]:='     '+stg(chno,2);

      case receiver[recno]^.units of
	  1:disp[1,3]:='     '+chr(248)+'C';
          2:disp[1,3]:='     '+chr(248)+'F';
          3:disp[1,3]:='      K';
          else disp[1,3]:='error';
          end;

          disp[1,4]:=iptypestring(txtype,input_type);

           if txtype = 1
            then
             begin {txtype=1 (831)}

               { display input type , safety drive, high alarm and low alarm }


	       if not(rtd and (chno=16))
		   then
		       begin

                            if input_type<>15
                              then disp[1,5]:=message[thc_drive+27];

			    disp[1,6]:=fstr(high_alarm,3);
			    disp[1,7]:=fstr(low_alarm,3);
		       end
		   else
		       begin
			    if input_type=15
			    then
				disp[1,4]:=message[16]
			    else
				disp[1,4]:=message[97];

			    disp[1,5]:=message[98];
			    disp[1,6]:=message[98];
			    disp[1,7]:=message[98];
		       end;

             { display digital zero and span (831)}

	       if not(rtd and (chno=16))
		   then
		       begin
			      disp[1,8]:=fstr(scale_ipzero,3);
			      disp[1,9]:=fstr(scale_opzero,3);
			      disp[1,10]:=fstr(scale_gain,3);
		       end
		   else
		       begin
			    disp[1,8]:=message[98];
			    disp[1,9]:=message[98];
			    disp[1,10]:=message[98];
		       end;


             end {txtype=1}

            else {txtype=2}
             begin

               { display safety drive, not applicable for 832 }

	       disp[1,5]:=message[98];

               { display high and low alarm settings }

	       disp[1,6]:=fstr(high_alarm,3);
	       disp[1,7]:=fstr(low_alarm,3);


	       { display zero and span (832)}

	       disp[1,8]:=fstr(scale_ipzero,3);
	       disp[1,9]:=fstr(scale_opzero,3);
	       disp[1,10]:=fstr(scale_gain,3);

         end; {txtype=2}

     disp[1,11]:='';

     gotoxy(47,8);
     write('Channel '+stg(chno,2)+'  ');
     gotoxy(47,10);
     write(message[42]);
     gotoxy(47,12);
     write(message[39]);
     gotoxy(47,14);
     write (message[41]+' 1    ');
     gotoxy(47,16);
     write (message[41]+' 2    ');
     gotoxy(47,18);
     write('HAN 83    ');

      i:=sel(4);
      case i of
	   $11:tranno;
	   $12:chano;
	   $13:tempunits;
	   $14:inputype;
	   $15:ocdrive;
	   $16:halarm;
	   $17:lalarm;
	   $18:ipzero;
	   $19:opzero;
	   $1A:gain;
           $1B:monip;
           $FF:escape:=true;
           end;
      end
until (i=$FF);

xcur:=oldx;
ycur :=oldy;
end;

{***************************************************************************}
procedure monall;
var
   i:integer;
   done:boolean;
   xtemp,ytemp:integer;
   num_channels:integer;
   txvalstype:byte;
   ch,x:char;



begin
done:=false;
repeat
     msgerror:=false;
     window(1,1,80,25);
     textbackground(black);
     gotoxy(1,25);
     write(message[53]);
     read_cj(recno,txno);
     if not msgerror then txvalstype:=read_vals(recno,txno);
     num_channels:=8*(3-txvalstype);
     if breakout then done:=true;
     gotoxy(1,25);
     write('                   ');
     textbackground(back);
     if not(msgerror) then
      begin
       for i:=1 to num_channels do
         with receiver[recno]^.transmitter[txno].channel[i] do
             begin
              if (i<=trunc(num_channels/2)) then
                 begin
                     xtemp:=8;
                     ytemp:=7+i;
                 end
                else
                 begin
                     xtemp:=47;
                     ytemp:=7+i-trunc(num_channels/2);
                 end;

              gotoxy(xtemp,ytemp);
              write('Channel '+stg(i,2)+'  ');
              gotoxy(xtemp+12,ytemp);
              write(value);
              case alarm of
                   off:write('        ');

                   high:begin
                        write(' ');
                        textbackground(errbar);
                        write(message[43]+' ');
                        textbackground(back);
                        end;

                    low:begin
                        write(' ');
                        textbackground(errbar);
                        write(message[44]+'  ');
                        textbackground(back);
                        end;
                    end; {case alarm}

             end ; {with receiver..}

       i:=trunc(num_channels/2);
       gotoxy(8,i+8);
       write(message[39]);
       gotoxy(20,i+8);
       if txvalstype=1 then
          write(receiver[recno]^.transmitter[txno].cjtemp
               ,receiver[recno]^.transmitter[txno].cjunit)
          else
              write('      N/A   ');
       gotoxy(8,i+10);
       write('HAN 83     ');
       gotoxy(18,i+10);
       write(message[56+ord(hht)]);
       gotoxy(47,i+8);
       write(message[40]);
       gotoxy(59,i+8);
       if receiver[recno]^.eld then
           write(message[48]+' ')
         else
           write(message[47]+' ');

       gotoxy(8,i+9);
       write(message[41]+' 1');
       gotoxy(47,i+9);
       write(message[41]+' 2');
       gotoxy(23,i+9);
       case receiver[recno]^.hw1 of
            true:write(message[45]+'   ');
            false:begin
                  textbackground(errbar);
                  write(message[46]);
                  textbackground(back);
                   end;
            end;
       gotoxy(62,i+9);
       case receiver[recno]^.hw2 of
            true:write(message[45]+'    ');
            false:begin
                  textbackground(errbar);
                  write(message[46]);
                  textbackground(back);
                  end;
            end; {case}

     end;  { if not msgerror}
gotoxy(5,23);
write('                           ');
gotoxy(80,25);
if  (msgerror or oldvals) and not(done) then
 begin
   gotoxy(5,23);
   textbackground(errbar);
   write(errmsg);
   textbackground(back);
   gotoxy(80,25);
   write(^g);
   delay(5000);
 end;
until done;
backgnd(1);
end;

{***************************************************************************}
procedure textdemo;

var
oldx,oldy,i:byte;

begin
escape:=false;
backgnd(1);
oldx:=xcur;
oldy:=ycur;
xcur:=1;
ycur:=4;
repeat
      begin
      disp[1,1]:=stg(recno,5);
      disp[1,2]:=stg(txno,5);
      disp[1,3]:='   838  ';
      disp[1,4]:='';

      i:=sel(3);
      case i of
           $11:{receiver fixed};
           $12:begin
	       tranno;
               escape:=false;
	       backgnd(1);
	       end;
	   $13:{rxtype fixed MTL838};
           $14:monall;
           $FF:escape:=true;
           end;
      end
until escape;
xcur:=oldx;
ycur:=oldy;
end;

{***************************************************************************}
end.

