unit globals;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,crt,windows,messages,dos, synaser, synautil, synafpc ;
 type

    Channel_data = record          {parameters for each channel}
                         value:string[20];
                         vunit:string[2];
                         high_alarm:real;
                         low_alarm:real;
                         alarm:(high, low, off);
                         input_type:byte;
                         THC_drive:byte;
			 scale_ipzero:real;
			 scale_opzero:real;
			 scale_gain:real;

     end;

   transmitter_data = record           {parameters for each transmitter}
                       txtype:byte;
		       cjtemp:string[20];
                       cjunit:string[2];
                       channel:packed array[1..16] of channel_data;

   end;



   reciever_data = record
			 tag_field:string[25];
			 hcaver:string[10];
			 ipver:string[10];
			 add_mode:boolean; {true=software false=hardware}
			 mod_addressA:byte;
			 mod_addressB:byte;
			 data_format:byte;
			 comm_mode:boolean; {true=software false=hardware}
			 mod_baud:byte;    {1=300,2=600,3=1200,4=2400,
					   5=4800,6=9600,7=19200,8=38400
					   note 38k4 not currently allowed}
			 mod_parity:byte;  {0=none,1=odd,2=even}
                         mod_dbits:byte; {0=7bit, 1=8bit}
			 mod_stop:byte;
			 mod_mode:byte; {0=ASCII, 1=RTU, 2=undefined}
			 check_mode:byte;
			 checksum:longint;
                         ramchksum:longint;
                         cksum_base:byte;  {0=decimal , 1=hex}
			 no_of_tx:byte;
			 units:byte;   {1=C, 2=F, 3=K}
                         status1:byte;
                         status2:byte;
			 hw1:boolean;  {flag highway1 o.k.}
			 hw2:boolean;
			 eld:boolean;  {flag for Earth Leakage Detection}
			 sysfail:boolean;
			 line_rej:byte;
			 hcaswitch:byte;
			 ipswitch:byte;
			 transmitter:packed array[1..4] of transmitter_data;

       end;

   config_data = record
		       rxconfig:array[0..15] of boolean;
   end;



const
     head=4;  { defines the length-1 of the header in a received message }
     rxmaxno=1;
     TROLLOVER=100000;

var
  {   rxpoint:^reciever_data;}
       tag_field1:string[25];
   ExitSave:pointer;
   Int1CSave:pointer;
   tic:longint;
   tictimeout:boolean;
   Port_Selection:boolean;
   message:array[1..100] of string[19];
   globdat:config_data;
   receiver:array[0..rxmaxno] of ^reciever_data;
   receiver_present: array [0..15] of boolean;
   path,name: string[255];
   filename:string[12];
   breakout,msgerror,hht,oldvals:boolean;
   errmsg:string[17];
   port,recno,txno,chno:byte;
   menutext,maintext,back, bartext, errbar,
   menu, graphback, normfill, alarmfill:byte;
 {  Application: aa;}
   serial1 : TBlockSerial;
   data_Rerceived : byte;
   No_Of_Ports:byte;
   COM_Port_Name:array[1..40] of string[50];
   Avai_Ports:string;
   selected_port_name:string;
   Column_Number:byte;
implementation

end.

