unit wind;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, crt, windows, messages,globals,misc,comms,synaser;
 type

    menuelement= record
                 title :string[15];
                 xpos:byte;
                 ypos:byte;
                 hstr1:string[30];
                 hstr2:string[30];
                 end;



    scrn =       record
                 cell:array[1..2,1..14] of menuelement;
                 maxx:byte;
                 maxy:array[1..2] of byte;
                 end;

    opt  =       record
                 receiver:byte;
                 transmitter:byte;
                 channel:byte;
                 end;


    datastring = array[1..16] of string[16];

const

     dformatstg:datastring = (
                       '    IEEE        ',
                       'reverse IEEE    ',
                       '16BIT Unsigned  ',
                       ' 16BIT offset   ',
                       '16BIT 2s comp   ',
                       ' 16BIT signed   ',
                       '12BIT Unsigned  ',
                       ' 12BIT offset   ',
                       '12BIT 2s comp   ',
                       ' 12BIT signed   ',
                       '   4DEC BCD     ',
                       '4DEC offset BCD ',
                       '4DEC BCD comp   ',
                       '   3DEC BCD     ',
                       '3DEC offset BCD ',
                       '3DEC BCD comp   ');

     iptype831a:datastring = (
                       '     mV         ',
                       '  E  THC no CJ  ',
                       '  J  THC no CJ  ',
                       '  K  THC no CJ  ',
                       '  N  THC no CJ  ',
                       '  R  THC no CJ  ',
                       '  T  THC no CJ  ',
                       ' E  THC with CJ ',
                       ' J  THC with CJ ',
                       ' K  THC with CJ ',
                       ' N  THC with CJ ',
                       ' R  THC with CJ ',
                       ' T  THC with CJ ',
                       'RTD Ohmic Output',
                       'RTD Temp Output ',
                       ' -----more----- ');


     iptype831b:datastring = (
                       '  S THC no CJ  ',
                       '  S THC with CJ ',
                       '  E THC mV+CJ   ',
                       '  J THC mV+CJ   ',
                       '  K THC mV+CJ   ',
                       '  N THC mV+CJ   ',
                       '  R THC mV+CJ   ',
                       '  T THC mV+CJ   ',
                       '  S THC mV+CJ   ',
                       '  B THC mV+CJ   ',
                       '  B THC no CJ   ',
                       '  B THC with CJ ',
                       ' -----more----- ',
                       ' ', ' ',' ');
     iptype832:datastring = (
                       '      mA        ',
                       '   RTD ohmic    ',
                       '     SQRT       ',
                       '','','','','','',
                       '','','','','','',
                       '');


     no_of_screens = 10;
var
     serial1 : TBlockSerial;
   txt:array[0..20] of string[19];
   screen:array[1..no_of_screens] of scrn;
   disp:array[1..2,1..12] of string[16];
   xcur,ycur,scno,lpt:byte;

   rtd,online,escape :boolean;

   procedure comportscan();
   procedure clearport();
   procedure COM_Port_Status(Status_1:byte);
    procedure comportscan1();
   procedure setwindow1(x1,y1,x2,y2:integer);
   function  fstr(i:real;a:byte):string;
   function  sel(no:byte):byte;
   procedure clrwindow(x,y,no:integer);
   function  selection(no,select,esc:byte):byte;
   procedure drawwindow(x,y,no:byte);
   function  getnum(currentval:real;rng:integer):real;
   procedure setwindow(x1,y1,x2,y2:integer);
   procedure getdat(i:byte);
   procedure fillscn(curx,cury:byte);
   procedure upload;
   procedure dump(rx,tx:byte);
   procedure download;
   procedure onlinprog;
   procedure comport1;
   procedure baudrate(rx:byte);
   procedure sbits(rx:byte);
   procedure parity(rx:byte);
   procedure checksum_base(rx:byte);
   procedure databits(rx:byte);
   procedure address(rx,link:byte);
   procedure rxno;
   procedure tag;
   procedure datafmt;
   procedure dfscale(rx,ttype:byte);
   procedure noftx;
   procedure tempunits;
   procedure checksum_mode;
   procedure tranno;
   procedure chano;
   procedure ocdrive;
   procedure halarm;
   procedure lalarm;
   procedure ipzero;
   procedure opzero;
   procedure gain;
   procedure readonly;
   procedure readonly2;
   procedure saynonegatives;
   procedure saydone(s:string);
   procedure sayerror(s:string);
   procedure signoffmess;
   function pport(file1:string):string;
   procedure hertz;
   procedure tx_type;
   procedure initwind;
   procedure reset_rx(recno,rectype:byte);
   procedure sw101;
   procedure sw301;
   function iptypestring(tx_type,input_type:byte):string;
   function  selection_string(no,select,esc:byte):string;
{   procedure New_port_Init(Portname:string);}
implementation
procedure  fillscn(curx,cury:byte);

var
   i,j:integer;

begin
textbackground(back);
textcolor(maintext);
with screen[scno] do
  for i:=1 to maxx do
    for j:=1 to maxy[i] do
      with cell[i,j] do
         begin
         if (i=curx) and (j=cury) then
                     begin
                     window(4,21,37,23);
                     clrscr;
                     writeln(hstr1);
                     write(hstr2);
                     window(1,1,80,25);
                     textbackground(15);
                     textcolor(bartext);
                     gotoxy(xpos,ypos);
                     write(title);
                     textbackground(back);
		     textcolor(maintext);
		     write('   ',disp[i,j]);
		     end
	 else
		     begin
		     gotoxy(xpos,ypos);
		     write(title,'   ',disp[i,j]);
		     end;
	 end;

gotoxy(80,25);
 cursoroff;
end;
{**************************************************************************}
procedure cursorup;

begin
  repeat
  if ycur=1 then
    begin
     ycur:=screen[scno].maxy[xcur];
     if screen[scno].cell[xcur,ycur].hstr1='##' then
          dec(ycur);
     end
  else
     dec(ycur);
  until screen[scno].cell[xcur,ycur].hstr1<>'##';
end;
{**************************************************************************}
procedure cursordown;

begin
  repeat
   if ycur=screen[scno].maxy[xcur] then
     begin
      ycur:=1;
      if screen[scno].cell[xcur,ycur].hstr1='##' then
           inc(ycur);
      end
     else
      inc(ycur);
  until screen[scno].cell[xcur,ycur].hstr1<>'##';
end;
{**************************************************************************}

function  sel(no:byte):byte;


var
   ch,oldch:char;

begin
scno:=no;
with screen[no]  do
   begin
   fillscn(xcur,ycur);
   repeat
      begin
      oldch:=ch;
      ch:=readkey;
      case ch of
              #72:{up arrow}
                  Begin
                  if (oldch=#0) then
                          begin
                          cursorup;
                          fillscn(xcur,ycur);
                          end
                   end;

              #80:{down arrow}
                  Begin
                  if (oldch=#0) then
                          begin
                          cursordown;
                          fillscn(xcur,ycur);
                          end
                   end;

              #75:{left arrow}
                  Begin
                  if (oldch=#0) then
                          begin
                          if xcur=1 then
                               xcur:=maxx
                          else
                             dec(xcur);
                          if ycur > maxy[xcur] then
                              ycur := maxy[xcur];
                          if screen[scno].cell[xcur,ycur].hstr1='##'
                                  then
                                   cursordown;
                          fillscn(xcur,ycur);
                          end
                   end;

              #77:{right arrow}
                  Begin
                  if (oldch=#0) then
                          begin
                          if xcur=maxx then
                             xcur:=1
                          else
                             inc(xcur);
                          if ycur > maxy[xcur] then
                              ycur := maxy[xcur];
                          if screen[scno].cell[xcur,ycur].hstr1='##'
                                  then
                                   cursordown;
                          fillscn(xcur,ycur);
                          end
                   end;

              #45:{Alt-X}
                  Begin
                  if (oldch=#0) then
                          begin
                          gotoxy(1,25);
                          textcolor(white);
                          textbackground(black);
                          write(message[96]);
                          ch:=readkey;
                          if ch in ['y','Y'] then
                             begin
                             cursoron;
                             clrscr;
                             halt;
                             end
                          else
                              begin
                              gotoxy(1,25);
                              write('                      ');
                              textcolor(15);
                              textbackground(back);
                              end;
                          end
                   end;

               #27:{escape}
                   begin
                   sel:=$ff;
                   end;

               #13:{return}
                   begin
                   sel:=xcur*16+ycur;
                   end;

              end;
        end
   until (ch=#27) or (ch=#13);
   end;
end;


{***********************************************************************}
procedure clrwindow(x,y,no:integer);

begin
window(x-1,y-1,x+19,y+no+2);
clrscr;

end;

{***************************************************************************}
procedure setwindow(x1,y1,x2,y2:integer);

  const
    upleftcorner   = #201;
    horzbar        = #205;
    uprightcorner  = #187;
    vertbar        = #186;
    lowleftcorner  = #200;
    lowrightcorner = #188;

  var
    i  : integer;

  begin
    window(x1-1,y1-1,x2+x1+1,y2+y1+1);
    gotoxy(1,1);
    write(upleftcorner);
    for i := 2 to x2 do
      write(horzbar);
    write(uprightcorner);
    for i := 2 to y2 do
      begin
	gotoxy(1,i);write(vertbar);
	gotoxy(x2+1,i);write(vertbar)
      end;

    gotoxy(1,y2+1);
    write(lowleftcorner);
    for i :=2 to x2 do
      write(horzbar);
    write(lowrightcorner);
    gotoxy(1,3);
    write(#204);
    for i:=2 to x2 do
        write(horzbar);
    write(#185);
    window(x1,y1,x2+x1-1,y2+y1-1);
  end;

procedure setwindow1(x1,y1,x2,y2:integer);

  const
    upleftcorner   = #201;
    horzbar        = #205;
    uprightcorner  = #187;
    vertbar        = #186;
    lowleftcorner  = #200;
    lowrightcorner = #188;

  var
    i  : integer;

  begin
    window(x1-1,y1-1,x2+x1+1,y2+y1+1);
    gotoxy(1,1);
    write(upleftcorner);
    for i := 2 to x2 do
      write(horzbar);
    write(uprightcorner);
    for i := 2 to y2 do
      begin
	gotoxy(1,i);write(vertbar);
	gotoxy(x2+1,i);write(vertbar)
      end;

    gotoxy(1,y2+1);
    write(lowleftcorner);
    for i :=2 to x2 do
      write(horzbar);
    write(lowrightcorner);
    gotoxy(1,3);
    write(#204);
    for i:=2 to x2 do
        write(horzbar);
    write(#185);
    window(x1,y1,x2+x1-1,y2+y1-1);
  end;


{****************************************************************************}
  procedure inverse;

  begin
    textbackground(15);
    textcolor(bartext);
  end;
{**************************************************************************}

  procedure normal;

  begin
    textbackground(menu);
    textcolor(menutext);
  end;
{***************************************************************************}
function  selection(no,select,esc:byte):byte;

var
   ch:char;
   ti:byte;

begin
     repeat

        escape:=false;
        gotoxy(1,(select+2));
        inverse;
        ti:=select;
        write(txt[select]);
        gotoxy(20,no+3);
        normal;
        repeat
          ch:=readkey;
          if ch <> #0 then
	    begin
	      if ch <> #13 then
                begin
                  if (ch = #72) or (ch = #80) then
	            begin
                      gotoxy(1,(select+2));
                      write(txt[select]);
                      if ch = #72 then select :=select-1 else select := select+1;
                      if select < 1  then select := no;
                      if select > no then select := 1;
	            end;
                  if (ch=#27) then
                     begin
                     select:=esc;
                     escape:=true;
                     ch:=#13;
                     end;
	        end;
	    end;
       until (ch = #13) or (ch=#72) or (ch=#80);
    until (ch = #13);
    selection:=select;
end;
function  selection_string(no,select,esc:byte):string;

var
   ch:char;
   len1,len2,ti:byte;
   temps1:string;

begin
     repeat

        escape:=false;
        gotoxy(1,(select+2));
        inverse;
        ti:=select;
        write(txt[select]);
        gotoxy(20,no+3);
        normal;
        repeat
          ch:=readkey;
          if ch <> #0 then
	    begin
	      if ch <> #13 then
                begin
                  if (ch = #72) or (ch = #80) then
	            begin
                      gotoxy(1,(select+2));
                      write(txt[select]);
                      if ch = #72 then select :=select-1 else select := select+1;
                      if select < 1  then select := no;
                      if select > no then select := 1;
	            end;
                  if (ch=#27) then
                     begin
                     select:=esc;
                     escape:=true;
                     ch:=#13;
                     end;
	        end;
	    end;
       until (ch = #13) or (ch=#72) or (ch=#80);
    until (ch = #13);

    len1:= (pos('C',txt[select]));
    len2 := length(txt[select]);
        temps1 := copy(txt[select],len1,(len2-len1));
        len2 := length(temps1);
        len1 :=pos(' ',temps1);
        temps1 := copy(temps1,1,(len2-len1));
  {    window(1,1,80,25);
  gotoxy(1,30);

                 write(temps1);
                 readln;
    write(len1);
        write(len2);
    readln;   }
    selection_string:=temps1;
end;




{***************************************************************************}
  procedure drawwindow(x,y,no:byte);
var
i:byte;

begin
     gotoxy(1,25);
     textbackground(RED);
     textcolor(menutext);
     write(message[52]);
     normal;
     window(x,y,x+19,y+no+1);
     clrscr;
     setwindow(x,y,20,no+3);
     gotoxy(1,1);
     write(txt[0]);
     gotoxy(1,3);
      for i:=1 to no do
         writeln(txt[i]);

 end;
{***********************************************************************}
function stg(i,j:integer):string;

var
   x:string;
begin
str(i:j,x);
stg:=x;
end;
{************************************************************************}
function fstr(i:real;a:byte):string;

var
   x:string;

begin

str(i:10:4,x);

with receiver[recno]^.transmitter[txno].channel[chno]
  do begin
    case a of
    0:{831}
        begin
              case input_type of
		0:fstr:=x+' mV';
		13:fstr:=x+' '+chr(234);  {resistance}
		15:fstr:=x+'   ';
                else
                   case receiver[recno]^.units of
                     1:fstr:=x+chr(248)+'C';
                     2:fstr:=x+chr(248)+'F';
                     3:fstr:=x+' K';
                     else fstr:='?';
                   end;
               end;
           end;
    1:{832}
         begin
            case input_type of
	      0: fstr:=x+'mA';
	      1..6:fstr:=x;
	      13,14:fstr:=x+' '+chr(234);
	      15:fstr:=x+'  ';
              end;
         end;
    else fstr:=x;
    end; {case a of}

  end; {do begin}

end;

{*************************************************************************}

function strg(x:real;i:byte):string;

var
   y:string;

begin
     str(x:i,y);
     strg:=y

end;

{****************************************************************************}
function sftrg(x:real;i,j:byte):string;
var
   y:string;

begin
     str(x:i:j,y);
     sftrg:=y

end;

{****************************************************************************}
function getname(s:shortstring):shortstring;


var
   curpos,beg,j:byte;
   m:real;
   i,iprev:char;
   olds:string;
begin
escape:=false;
olds:=s;
i:=#01;
j:=0;

for j:=(length(s)+1) to 255 do s[j]:=' ';;

curpos:=1;
cursoron;

repeat
begin
     if curpos>15 then
        begin
        beg:=curpos-14;
        gotoxy(2,3);
        for j:= beg to curpos do write (s[j]);
        end
     else
        begin
        beg:=1;
        gotoxy(2,3);
        for j:= 1 to 15 do write (s[j]);
        end;
     gotoxy(curpos-beg+2,3);
     iprev:=i;
     i:=readkey;

     if ((i in['0'..'9','a'..'z','A'..'Z','.','\',':','@','_',' ']) and(curpos<>25) and (iprev<>#0)) then
        begin
        s:=copy(s,1,curpos-1)+i;
        inc(curpos);
        end;

     if (((i=#83)and (iprev=#0)) or (i=#8)) and (curpos<>1) then
        begin
        dec(curpos);
        s:=copy(s,1,curpos-1);
        end;
     if i<>#13 then  for j:=curpos to 255 do s[j]:=' ';
     getname:=s;
     if i=#27 then
              begin
              getname:=olds;  {pressed escape key}
              escape:=true;
              i:=#13;
              end;
end;
until i=chr(13);
gotoxy(1,4);
write('                   ');
cursoroff;
end;


{****************************************************************************}
function  getnum(currentval:real;rng:integer):real;

{type = 0 : real number required}
{       1 : byte                }

var
   code:integer;
   curpos,j:byte;
   i:char;
   min,max:real;
   v:real;

begin
escape:=false;
curpos:=4;
cursoron;

case rng of
	    0: begin
                str(currentval:10:3,txt[1]);
                txt[1]:='   '+txt[1];
		min:=-99999;
		max:=99999;
	       end;
	    1: begin
		str(currentval:3:0,txt[1]);
		txt[1]:='   '+txt[1];
		min:=0;
		max:=255;
               end;
	    else {error};
	    end;  {case rng}

txt[2]:='';
repeat
   drawwindow(30,15,2);
   gotoxy(curpos,3);

   repeat
         i:=readkey;
         if i<>chr(13) then
               begin
               if (i in['0'..'9','.','+','-']) and (curpos<>13) then
                    begin
                     txt[1]:=copy(txt[1],1,curpos-1)+i;
                     inc(curpos);
                    end;
               if ((i=#83) or (i=#8)) and (curpos>4) then
                    begin
                     dec (curpos);
                     txt[1]:=copy(txt[1],1,curpos-1);
                    end;
               gotoxy(1,3);
               write('                  ');
               gotoxy(1,3);
               write(txt[1]);
               gotoxy(curpos,3);

               if (i=#27) then
                    begin
                    escape:=true;
                    end;

          end; {if i<>13}
   until escape or (i=chr(13));

   code:=0;
   if not escape then
        begin
           val(txt[1],v,code);
           if (v>max) or (v<min) then code:=1;
           getnum:=v;
           if code<>0 then
             begin
                   txt[2]:=' Error- Try again';
                   write(^g);
             end;
        end
     else
         getnum:=currentval;

until (code=0) or escape;
cursoroff;
end;

{****************************************************************************}
procedure upload_tx(rx,tx:byte);
{created 25/1/92 aps}
{** This local procedure uploads the data for a single selected transmitter **}
{** The global variable msgerror is set true if an error is detected **}

var
k,nochanns:integer;
a:boolean;

begin
with receiver[rx]^ do
   with transmitter[tx] do
       begin
       read_txtype(rx,tx);
       case txtype of
	    1:nochanns:=16;
	    2:nochanns:=8;
	    else nochanns:=8;
       	    end; {case txtype}
       for k:=1 to nochanns do
       with channel[k] do
	   begin
	   gotoxy(1,25);
	   if not msgerror then
	      write(' Uploading  Rx '+stg(rx,2)+' Tx '+stg(tx,2)+' Ch '+stg(k,2));
           read_scales(rx,tx,k);
           read_alarms(rx,tx,k);
           read_inptype(rx,tx,k);
           end; {with channel}
       end; {with transmitter}

end; {procedure upload_tx}

{****************************************************************************}
procedure getdat(i:byte);

var
   j:integer;

begin
window(1,1,80,25);
msgerror:=false;
   with receiver[i]^ do
   begin
   textbackground(black);
   gotoxy(1,25);
   write('                                                                   ');
   gotoxy(1,25);
   write(' Uploading Configuration ');

   msgerror:=false;
    tag_field:='';
   read_tag(i);


   if breakout then exit;
   read_datafmt(i);

   if breakout then exit;
   read_temp(i);

   if breakout then exit;
   read_no_tx(i);


   if breakout then exit;
   read_vers(i);


   if breakout then exit;
   read_comms(i);
   if breakout then exit;
   read_address(i);

   if breakout then exit;
   read_checksum(i);
   if breakout then exit;
   read_csummode(i);
   if breakout then exit;
   read_switches(i);
   if breakout then exit;
   read_linerej(i);
   if breakout then exit;
   if not(msgerror) then
      for j:=1 to no_of_tx do
          begin
	    upload_tx(i,j);
            if breakout then exit;
          end;
   end; {with receiver}
   if msgerror then
      begin
      wrterror;
      gotoxy(5,23);
      textbackground(back);
      write('                       ');
      end
    else
         begin
         receiver_present[i]:=true;
         globdat.rxconfig[i]:=true;
         end;
    textbackground(black);
    gotoxy(1,25);
    write('                                                   ');
end;
{****************************************************************************}
procedure upload;

var
   i:byte;
   b,c:longint;

begin
getdat(0);
if breakout then
      begin
      wrterror;
      gotoxy(5,23);
      textbackground(back);
      write('                       ');
      end;
end;

{***************************************************************************}
procedure dump(rx,tx:byte);

{downloads data to receivers,transmitters}
{ if tx=$ff then download to all transmitters}
{ if tx=$f4  then download to 1..no_of_tx }

var
nochanns,t:integer;

procedure dltransmit(j:integer);

var
a:boolean;
k:integer;

begin
with receiver[rx]^.transmitter[j] do
  begin
     {txtype}
     set_txtype(rx,j);
     if breakout then exit;
     case txtype of
          1:nochanns:=16;
          2:nochanns:=8;
          end; {case}
     for k:=1 to nochanns do
       with channel[k] do
        begin
         gotoxy(1,25);
         if not msgerror then
           write(' Downloading  Tx '+stg(j,2)+' Ch '+stg(k,2));
         set_inptype(rx,j,k);
         if breakout then exit;
         set_scales(rx,j,k);
         if breakout then exit;
         set_alarms(rx,j,k);
         if breakout then exit;
        end;  {with channel}
  end; {with receiver}
end; {procedure dltransmit}


begin {main - prodedure dump}

window(1,1,80,25);
textbackground(black);
gotoxy(1,25);
write(' Downloading Rx'+stg(rx,2)+'                        ');
msgerror:=false;
receiver_present[rx]:=true;

if receiver_present[rx] then
      with receiver[rx]^ do
         begin
            msgerror:=false;
            set_tag(rx);
            if breakout then exit;
            set_datafmt(rx);
            if breakout then exit;
	    set_temp(rx);
            if breakout then exit;
            set_no_tx(rx);
            if breakout then exit;
            set_comms(rx);
            if breakout then exit;
            set_linerej(rx);
            if breakout then exit;
            set_address(rx);
            if breakout then exit;
            t:=1;
            case tx of
              $ff: for t:=1 to 4  do
                   begin
                    dltransmit(t);
                    if breakout then exit;
                   end;
	      $f4: while (t<= no_of_tx) do
                     begin
	       	      dltransmit(t);
                      if breakout then exit;
		      inc(t);
                     end; {case $f4}
              1..4: dltransmit(tx);
              end; {case tx}
         end; {with receiver}

if msgerror then
      begin
      wrterror;
      gotoxy(5,23);
      textbackground(back);
      write('                        ');
      end; {if msgerror}
textbackground(black);
gotoxy(1,25);
write('                                   ');


end; {dump}


{**************************************************************************}
procedure download;

begin
dump(0,$f4);
if msgerror then
      begin
      wrterror;
      gotoxy(5,23);
      textbackground(back);
      write('                        ');
      end; {if msgerror}
textbackground(black);
gotoxy(1,25);
write('                                   ');
end;


{***************************************************************************}
procedure onlinprog;

var
   i:integer;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='     Offline         ';
txt[2]:='     Online          ';

drawwindow(30,15,2);
i:=selection(2,ord(online)+1,ord(online)+1)-1;
case i of
     0:online:=false;
     1:online:=true;
     end;

end;
procedure clearport();
var
   i:integer;
begin
for i:=0 to 39 do
  begin
     COM_Port_Name[i]:= '';
  end;
end;
procedure comportscan();
var
   i:integer;
   temp,strlen:integer;
begin
Port_Selection:=false;
{serial1.Free;}
     clearport;
     No_Of_Ports:=0;
       selected_port_name:='';
       COM_Port_Name[0]:='';
    serial1:=TBlockSerial.Create;
  serial1.Config(9600,8,'N',SB1,false,false);
  COM_Port_Name[0]:=GetSerialPortNames;

  i:=0;
  if (COM_Port_Name[0] <> '') then
     begin
            repeat
          begin
              temp:= (pos(',',COM_Port_Name[0]));
              strlen :=  (length(COM_Port_Name[0]));
              if temp > 0 then
                 begin
                       COM_Port_Name[i+1] := copy(COM_Port_Name[0],1,(temp-1));
                      COM_Port_Name[0] := copy(COM_Port_Name[0],temp+1,(strlen-temp));
                      i:=i+1;
                 end
              else
              begin
              COM_Port_Name[i+1] :=  COM_Port_Name[0];
              i:=i+1;
              end;

          end;

      until ((temp = 0) or (Port_Selection=true));
      No_Of_Ports := i;
  selected_port_name :=COM_Port_Name[1];
    serial1.free;
    {init_comport(selected_port_name);}
      end
  else
  begin
   end;

end;
 procedure comportscan1();
var
   i:integer;
   temp,strlen:integer;
begin
Port_Selection:=false;
{serial1.Free;}
     clearport;
     No_Of_Ports:=0;
       selected_port_name:='';
       COM_Port_Name[0]:='';
    serial1:=TBlockSerial.Create;
  serial1.Config(9600,8,'N',SB1,false,false);
  COM_Port_Name[0]:=GetSerialPortNames;
    Avai_Ports := GetSerialPortNames;
  i:=0;
  if (COM_Port_Name[0] <> '') then
     begin
            repeat
          begin
              temp:= (pos(',',COM_Port_Name[0]));
              strlen :=  (length(COM_Port_Name[0]));
              if temp > 0 then
                 begin
                       COM_Port_Name[i+1] := copy(COM_Port_Name[0],1,(temp-1));
                        init_comport(COM_Port_Name[i+1]);
                       Check_Port(COM_Port_Name[i+1]);
                      COM_Port_Name[0] := copy(COM_Port_Name[0],temp+1,(strlen-temp));
                      i:=i+1;
                 end
              else
              begin
              COM_Port_Name[i+1] :=  COM_Port_Name[0];
              init_comport(COM_Port_Name[i+1]);
              Check_Port(COM_Port_Name[i+1]);
              i:=i+1;
              end;

          end;

      until ((temp = 0) or (Port_Selection=true));
      No_Of_Ports := i;
 { selected_port_name :=COM_Port_Name[1];
    serial1.free;
    init_comport(selected_port_name);
  }

      end
  else
  begin
   end;

end;
{************************************************************************}
procedure comport1;
var
s:string;
Port_Name:text;
temp1:byte;
begin
comportscan;
 temp1:=1;
 txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
 if (No_Of_Ports = 0) then
  begin
   txt[0]:='COM PORT NOT EXIST';
   txt[1]:='        OK        ';
      drawwindow(30,13,1);
   if (selection(1,1,1)=1) then
              begin
              end
   end
 else
 begin
  repeat
        txt[temp1]:='       '+COM_Port_Name[temp1]+'       ';
        temp1 :=temp1+1;
 until (temp1=(No_Of_Ports+1));
  drawwindow(30,15,No_Of_Ports);
  selected_port_name := selection_string(No_Of_Ports,1,1);
  init_comport(selected_port_name);
   disp[2,3]:='    ' + selected_port_name;
 end;
  end;



{************************************************************************}
procedure baudrate(rx:byte);
var
   old,i:byte;

begin
if (receiver[rx]^.comm_mode)  { if comms are software selected}
then
    begin
        txt[0]:='  '+screen[scno].cell[xcur,ycur].title;
        txt[1]:='        300         ';
        txt[2]:='        600         ';
        txt[3]:='       1200         ';
        txt[4]:='       2400         ';
        txt[5]:='       4800         ';
        txt[6]:='       9600         ';
        txt[7]:='      19200         ';

        drawwindow(30,10,7);
        old:=receiver[rx]^.mod_baud;
        receiver[rx]^.mod_baud:=selection(7,old,old);

        if online and not(escape) then
	   begin
	   wrtworking;
           set_comms(rx);
           gotoxy(1,25);
           write('            ');
           if msgerror then
              begin
              wrterror;
              receiver[recno]^.mod_baud:=old;
              end;
            end;  { if online }

    end  { if comm_mode }
else
    {comms defined in hardware}
    begin
	readonly;
    end; {else}

end;

{************************************************************************}
procedure sbits(rx:byte);
var
   old,i:byte;
begin

if (receiver[rx]^.comm_mode) then {comms parameters software selected}
   begin
    txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
    txt[1]:='         1          ';
    txt[2]:='         2          ';

    drawwindow(30,15,2);
    old:=receiver[rx]^.mod_stop;
    receiver[rx]^.mod_stop:=selection(2,old,old);

    if online and not(escape) then
       begin
       wrtworking;
       set_comms(rx);
       gotoxy(1,25);
       write('            ');
       if msgerror then
           begin
             wrterror;
             receiver[recno]^.mod_stop:=old;
          end;
       end; {if online}
    end { if comm_mode then}
  else
    {comms parameters hardware defined}
    readonly;

end;
{************************************************************************}
procedure parity(rx:byte);
var
   i,old:byte;

begin
if (receiver[rx]^.comm_mode) then  { if comms are software selected }
begin
    txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
    txt[1]:='   '+message[31]+'       ';
    txt[2]:='   '+message[32]+'        ';
    txt[3]:='   '+message[33]+'       ';

    drawwindow(30,15,3);
    old:=receiver[rx]^.mod_parity;
    receiver[rx]^.mod_parity:=selection(3,old+1,old+1)-1;

    if online and not(escape) then
       begin
       wrtworking;
       set_comms(rx);
       gotoxy(1,25);
       write('            ');
       if msgerror then
          begin
             wrterror;
             receiver[recno]^.mod_parity:=old;
          end;
       end; {if online}
  end { if comm_mode then }
else
    {comms paramters hardware defined}
    readonly;

end;
{************************************************************************}
procedure checksum_base(rx:byte);
var
   old:byte;

begin
    txt[0]:='    Display As...   ';
    txt[1]:='      Decimal       ';
    txt[2]:='        Hex         ';

    drawwindow(30,15,2);
    old:=receiver[rx]^.cksum_base;  {0=decimal , 1=hex}
    receiver[rx]^.cksum_base:=selection(2,old+1,old+1)-1;
end;
{************************************************************************}

procedure databits(rx:byte);
var
   i,old:byte;

begin
if (receiver[rx]^.comm_mode) then  { if comms are software selected }
begin
    txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
    txt[1]:='         7          ';
    txt[2]:='         8          ';

    drawwindow(30,15,2);
    old:=receiver[rx]^.mod_dbits;
    receiver[rx]^.mod_dbits:=selection(2,old+1,old+1)-1;

    if online and not(escape) then
       begin
       wrtworking;
       set_comms(rx);
       gotoxy(1,25);
       write('            ');
       if msgerror then
          begin
             wrterror;
             receiver[recno]^.mod_dbits:=old;
          end;
       end; {if online}
  end { if comm_mode then }
else
    {comms paramters hardware defined}
    readonly;

end;
{************************************************************************}
procedure address(rx,link:byte);
var
   i,old:byte;
   tempval:integer;

begin
if (receiver[rx]^.add_mode) then  { if address is software selected }
begin
   if link=1 then
        begin
          txt[0]:=' Address Link A';
          old:=receiver[rx]^.mod_addressA;
	  receiver[rx]^.mod_addressA:=trunc(getnum(old,1));
        end
      else
        begin
          txt[0]:=' Address Link B';
          old:=receiver[rx]^.mod_addressB;
	  receiver[rx]^.mod_addressB:=trunc(getnum(old,1));
        end;

   if (online and not(escape)) then
       begin
       wrtworking;
       set_address(rx);
       gotoxy(1,25);
       write('            ');
       if msgerror then
          begin
             wrterror;
             receiver[recno]^.mod_parity:=old;
          end;
       end; {if online}
  end { if comm_mode then }
else
    {comms paramters hardware defined}
    readonly;
end;
{************************************************************************}
procedure rxno;

var
   i:integer;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
for i:=1 to 16 do
    txt[i]:=stg(i-1,10)+'           ';

drawwindow(30,5,16);
recno:=selection(16,recno+1,recno+1)-1;
txno:=1;
end;
{************************************************************************}
procedure tag;
var
   old:string[30];

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='';
txt[2]:='';
drawwindow(30,15,2);
old:=receiver[recno]^.tag_field;
receiver[recno]^.tag_field:=getname(receiver[recno]^.tag_field)+'                             ';
if online and not(escape) then
   begin
   wrtworking;
   set_tag(recno);
   gotoxy(1,25);
   write('            ');
   if msgerror then
      begin
      wrterror;
      receiver[recno]^.tag_field:=old;
      end;
    end;
end;

{************************************************************************}
procedure setunipolar(rx:byte);
{ looks for any negative alarms or scalings and sets them to zero}

var nochanns,j,k:integer;

begin
for j:=1 to receiver[rx]^.no_of_tx do
   with receiver[rx]^.transmitter[j] do
     begin
        case txtype of
             1:nochanns:=16;
             2:nochanns:=8;
             end; {case}
        for k:=1 to nochanns do
          with channel[k] do
           begin
             if scale_opzero < 0 then scale_opzero:=0;
             if scale_gain < 0 then scale_gain:=0;
             if high_alarm < 0 then high_alarm:=0;
             if low_alarm < 0 then low_alarm:=0;
           end; {with channel}
    end; {with receiver.transmitter}
end; {setunipolar}

{************************************************************************}
procedure datafmt;

var
   temp,old:byte;
   i:integer;

begin
     txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
     for i:=1 to 16 do
              txt[i]:='  '+dformatstg[i];

drawwindow(30,5,16);

case receiver[recno]^.data_format of
     0..1:old:=receiver[recno]^.data_format+1;
     4..14:old:=receiver[recno]^.data_format-1;
     16..18:old:=receiver[recno]^.data_format-2;
     else old:=1;
  end;

temp:=selection(16,old,old);
case temp of
     1..2:receiver[recno]^.data_format:=temp-1;
     3..13:receiver[recno]^.data_format:=temp+1;
     14..16:receiver[recno]^.data_format:=temp+2;
     end;

if online and not(escape) then
   begin
   wrtworking;
   set_datafmt(recno);
   gotoxy(1,25);
   write('            ');
   if (msgerror or breakout) then
      begin
        wrterror;
        receiver[recno]^.data_format:=old;
      end {if msgerror}
      else
          if unipolar(receiver[recno]^.data_format) then setunipolar(recno);
	  download;

   end; {if online}
end;
{***************************************************************************}
procedure dfscale(rx,ttype:byte);

var temp:byte;

begin
msgerror:=false;
escape:=false;

txt[0]:=' Reset Scalings?  ';
txt[1]:='        NO        ';
txt[2]:='        YES       ';
drawwindow(30,15,2);
temp:=selection(2,1,1);
if temp=2 then
   begin
        if online then
           begin
             wrtworking;
	     send_reset(rx,ttype+8);
	     gotoxy(1,25);
             write('            ');
             if msgerror then
                begin
                  wrterror;
                end
                else   {if msgerror}
		  send_confirm(recno);
                  upload;
           end { if online }
        else
            { offline - just reset data base }
            init_scales(rx,ttype);

   end; {temp=2}

end;
{************************************************************************}
procedure noftx;
var
   old:byte;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='         1         ';
txt[2]:='         2         ';
txt[3]:='         3         ';
txt[4]:='         4         ';
drawwindow(30,15,4);
old:=receiver[recno]^.no_of_tx;
receiver[recno]^.no_of_tx:=selection(4,receiver[recno]^.no_of_tx,receiver[recno]^.no_of_tx);
if txno>receiver[recno]^.no_of_tx then txno:=1;
if online and not(escape) then
   begin
   wrtworking;
   set_no_tx(recno);
   gotoxy(1,25);
   write('            ');
   if msgerror then
      begin
      receiver[recno]^.no_of_tx:=old;
      wrterror;
      end;
    end;
end;
{************************************************************************}
procedure tempunits;

var
   old:byte;


begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='        '+chr(248)+'C        ';
txt[2]:='        '+chr(248)+'F        ';
txt[3]:='         K         ';
drawwindow(30,15,3);
old:=receiver[recno]^.units;
receiver[recno]^.units:=selection(3,receiver[recno]^.units,receiver[recno]^.units);

if online and not(escape) then
   begin
   wrtworking;
   set_temp(recno);
   gotoxy(1,25);
   write('            ');
   if msgerror then
      begin
      receiver[recno]^.units:=old;
      wrterror;
      end;
    end; {if online}
end;

{************************************************************************}
procedure checksum_mode;

var
   old:byte;


begin

txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='        AUTO        ';
txt[2]:='       MANUAL       ';
drawwindow(30,15,2);
old:=receiver[recno]^.check_mode;
receiver[recno]^.check_mode:=selection(2,old+1,old+1)-1;

if online and not(escape) then
   begin
   wrtworking;
   set_csummode(recno);
   gotoxy(1,25);
   write('            ');
   if msgerror then
      begin
      receiver[recno]^.check_mode:=old;
      wrterror;
      end;
    end; {if online}

end;

{************************************************************************}
procedure tranno;

var
   i:integer;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
for i:=1 to 4 do
    txt[i]:=stg(i,10)+'           ';

if txno>receiver[recno]^.no_of_tx then txno:=1;

drawwindow(30,15,receiver[recno]^.no_of_tx);
txno:=selection(receiver[recno]^.no_of_tx,txno,txno);
end;

{************************************************************************}
procedure chano;

var
   i:integer;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
for i:=1 to 16 do
    txt[i]:=stg(i,10)+'           ';

if receiver[recno]^.transmitter[txno].txtype= 1 then
   begin
   drawwindow(30,5,16);
   chno:=selection(16,chno,chno);
   end

else
   begin
   if chno>8 then chno:=1;
   drawwindow(30,5,8);
   chno:=selection(8,chno,chno);
   end;
end;

{************************************************************************}
procedure ocdrive;

var
   i:integer;
   old:byte;
   a:boolean;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
with receiver[recno]^.transmitter[txno] do
   a:=  (txtype=1) and (channel[chno].input_type = 15);  { MTL831 switch - illegal }

with receiver[recno]^.transmitter[txno].channel[chno] do
  if not(a or (receiver[recno]^.transmitter[txno].txtype=2)) then
  { o/c drive not applicable for MTL832 }
     begin
     for i:=1 to 3 do
         txt[i]:='  '+message[i+26]+'        ';

     drawwindow(30,15,3);
     old:=thc_drive;
     thc_drive:=selection(3,thc_drive+1,thc_drive+1)-1;
     if online and not(escape) then
        begin
        wrtworking;
        set_inptype(recno,txno,chno);
        gotoxy(1,25);
        write('            ');
        if msgerror then
           begin
           thc_drive:=old;
           wrterror;
           end;
         end;
     end
else
    begin
    window(1,1,80,25);
    gotoxy(5,23);
    textbackground(errbar);
    write(message[98]);
    write(^g);
    delay(2000);
    end;

end;

{************************************************************************}
procedure halarm;

var
   old:real;
     a,b:boolean;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
{high alarm setting not applicable for switch input type i.e 831 input_type=15}

with receiver[recno]^.transmitter[txno] do
 begin
   a:=(txtype=1) and (channel[chno].input_type = 15);
   b:=IsRtd(recno,txno) and (chno=16);   { channel 16 = RTD sense }
 end;

if not(a or b) then

 with receiver[recno]^.transmitter[txno].channel[chno] do
   begin
   old:=high_alarm;
   high_alarm:=getnum(high_alarm, recno);
   if (unipolar(receiver[recno]^.data_format) and (high_alarm < 0)) then
      begin
      high_alarm:=old;
      saynonegatives;
      escape:=true;
      end;
   if online and not(escape) then
      begin
      wrtworking;
      set_alarms(recno,txno,chno);
      gotoxy(1,25);
      write('            ');
      if msgerror then
         begin
         high_alarm:=old;
         wrterror;
         end;
       end;
   end
else
    begin
    window(1,1,80,25);
    gotoxy(5,23);
    textbackground(errbar);
    write(message[98]);
    write(^g);
    delay(2000);
    end;
end;
{************************************************************************}
procedure lalarm;
var
   old:real;
     a,b:boolean;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;

with receiver[recno]^.transmitter[txno] do
 begin
   a:=(txtype=1) and (channel[chno].input_type = 15);
   b:=IsRtd(recno,txno) and (chno=16);   { channel 16 = RTD sense }
 end;

if not(a or b) then

 with receiver[recno]^.transmitter[txno].channel[chno] do
   begin
   old:=low_alarm;
   low_alarm:=getnum(low_alarm, 0);
   if (unipolar(receiver[recno]^.data_format) and (low_alarm < 0)) then
      begin
      low_alarm:=old;
      saynonegatives;
      escape:=true;
      end;
   if online and not(escape) then
      begin
      wrtworking;
      set_alarms(recno,txno,chno);
      gotoxy(1,25);
      write('            ');
      if msgerror then
         begin
         low_alarm:=old;
         wrterror;
         end;
       end;
   end
else
    begin
    window(1,1,80,25);
    gotoxy(5,23);
    textbackground(errbar);
    write(message[98]);
    write(^g);
    delay(2000);
    end;
end;
{************************************************************************}
procedure ipzero;
{ allows the input of input zero scaling factor scale_ipzero }

var
   old:real;
     a:boolean;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;

with receiver[recno]^.transmitter[txno].channel[chno] do
   begin
   old:=scale_ipzero;
   scale_ipzero:=getnum(scale_ipzero, 0);
   if online and not(escape) then
      begin
      wrtworking;
      set_scales(recno,txno,chno);
      gotoxy(1,25);
      write('            ');
      if msgerror then
         begin
         high_alarm:=old;
         wrterror;
         end;
      end;  {if online..}
   end; {with receiver..}
 end;
{************************************************************************}
procedure opzero;
{ allows the input of output zero scaling factor scale_opzero }

var
   old:real;
     a:boolean;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;

{ if rtd's are being used then no scaling is allowed on channel 16 }
if not(rtd and (chno=16)) then

 with receiver[recno]^.transmitter[txno].channel[chno] do
   begin
   old:=scale_opzero;
   scale_opzero:=getnum(scale_opzero, 0);
   if (unipolar(receiver[recno]^.data_format) and (scale_opzero < 0)) then
      begin
      scale_opzero:=old;
      escape:=true;
      saynonegatives;
      end;
   if online and not(escape) then
      begin
      wrtworking;
      set_scales(recno,txno,chno);
      gotoxy(1,25);
      write('            ');
      if msgerror then
         begin
         high_alarm:=old;
         wrterror;
         end;
       end;
   end
else
    begin
    window(1,1,80,25);
    gotoxy(5,23);
    textbackground(errbar);
    write(message[98]);
    write(^g);
    delay(2000);
    end;
end;
{************************************************************************}
procedure gain;
{ allows the input of output full scale factor scale_fsd }

var
   old:real;
     a:boolean;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;

{ if rtd's are being used then no scaling is allowed on channel 16 }
if not(rtd and (chno=16)) then

 with receiver[recno]^.transmitter[txno].channel[chno] do
   begin
   old:=scale_gain;
   scale_gain:=getnum(scale_gain, 0);
   if online and not(escape) then
      begin
      wrtworking;
      set_scales(recno,txno,chno);
      gotoxy(1,25);
      write('            ');
      if msgerror then
         begin
         high_alarm:=old;
         wrterror;
         end;
       end;
   end
else
    begin
    window(1,1,80,25);
    gotoxy(5,23);
    textbackground(errbar);
    write(message[98]);
    write(^g);
    delay(2000);
    end;
end;
 procedure COM_Port_Status(Status_1:byte);

{ prints out a READ ONLY message for items which are set in hardware }

var
   x,y:integer;
   key:char;
   Mess1,Mess2,Mess3:string;
begin
     if (Status_1 = 1) then
      begin
           Mess1 :=   'Receiver is Successfully';
           Mess2 :='   Connected with ' + selected_port_name;
           Mess3 := 'and Ready for Upload/Download';
      end
     else if (Status_1 = 2) then
      begin
           Mess1 :=   'Receiver is Not Connected';
           Mess2 :=   'with any of the available';
           Mess3 :=   '  ports: ' + Avai_Ports;
      end
     else if (Status_1 = 3) then
      begin
           Mess1 :=   'Serial port does not ';
           Mess2 :=   'Exist in the PC';
           Mess3 :=   '';
      end;

     x:=25;
     y:=15;
     normal;
     window(x-1,y-1,x+29,y+5);
     clrscr;
     setwindow(x,y,30,6);
     gotoxy(7,1);
    { write('READ ONLY');}
    write('CONNECTION STATUS');

     gotoxy(3,3);
    { write('This parameter is selected');}
{    write('Receiver is Successfully');}
write(Mess1);
     gotoxy(3,4);

{    write('Connected with ' + selected_port_name);}
write(Mess2);
      gotoxy(1,5);
{    write('and Ready for Upload/Download');}
write(Mess3);
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end;
{************************************************************************}
procedure readonly;

{ prints out a READ ONLY message for items which are set in hardware }

var
   x,y:integer;
   key:char;

begin

     x:=25;
     y:=15;
     normal;
     window(x-1,y-1,x+29,y+5);
     clrscr;
     setwindow(x,y,30,6);
     gotoxy(11,1);
     write('READ ONLY');
     gotoxy(3,3);
     write('This parameter is selected');
     gotoxy(3,4);
     write('by a switch in the MTL838');
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end; {readonly}

{************************************************************************}
procedure readonly2;

{ prints out a READ ONLY message for use on CALC SCALINGS screen}

var
   x,y:integer;
   key:char;

begin

     x:=22;
     y:=15;
     normal;
     window(x-1,y-1,x+35,y+6);
     clrscr;
     setwindow(x,y,36,7);
     gotoxy(15,1);
     write('READ ONLY');
     gotoxy(3,3);
     write('These parameters are calculated ');
     gotoxy(3,4);
     write('from the values entered on the  ');
     gotoxy(3,5);
     write('left hand side of the screen.');
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end; {readonly2}
{************************************************************************}
procedure saynonegatives;

{ prints out a negatives not allowed message for unipolar data formats}

var
   x,y:integer;
   key:char;

begin

     x:=22;
     y:=15;
     normal;
     window(x-1,y-1,x+35,y+5);
     clrscr;
     setwindow(x,y,36,6);
     gotoxy(8,1);
     write('UNIPOLAR DATA FORMAT');
     gotoxy(3,3);
     write('The selected data format does ');
     gotoxy(3,4);
     write('not allow negative output values.');
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end; {saynonegatives}
{************************************************************************}

procedure saydone(s:string);

{ prints out a DONE message}

var
   x,y:integer;
   key:char;

begin

     x:=25;
     y:=15;
     normal;
     window(x-1,y-1,x+28,y+4);
     clrscr;
     setwindow(x,y,29,5);
     gotoxy(11,1);
     write('  DONE  ');
     gotoxy(3,3);
     write(s+' completed');
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end; {saydone}
{************************************************************************}

procedure sayerror(s:string);

{ prints out an ERROR message}

var
   x,y:integer;
   key:char;

begin

     x:=25;
     y:=15;
     normal;
     window(x-1,y-1,x+28,y+4);
     clrscr;
     setwindow(x,y,29,5);
     gotoxy(11,1);
     write('  ERROR  ');
     gotoxy(3,3);
     write(s);
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end; {saydone}

{************************************************************************}


procedure signoffmess;


var
   x,y:integer;
   key:char;

begin

     escape:=false;
     x:=22;
     y:=15;
     normal;
     window(x-1,y-1,x+35,y+6);
     clrscr;
     setwindow(x,y,36,7);
     gotoxy(15,1);
     write('SIGNOFF');
     gotoxy(3,3);
     write('Before sending this command the');
     gotoxy(3,4);
     write('configuration link on the MTL838');
     gotoxy(3,5);
     write('should be removed.');
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                      ');
     textbackground(errbar);
     write(' Any key to Continue, ESC to abort');
     window(1,1,80,25);
     key:=readkey;
     if key=#27 then escape:=true;
     normal;
     window(1,1,80,25);
end; {signoffmess}
{************************************************************************}


function pport(file1:string):string;

var
   i:integer;

begin
pport:=file1;
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
for i:=1 to 3 do
    txt[i]:='     LPT'+stg(i,1)+'           ';
    txt[4]:='     FILE          ';
drawwindow(30,15,4);
lpt:=selection(4,lpt,lpt);
if lpt=4 then
     begin
	txt[0]:='    Filename       ';
	txt[1]:='';
	txt[2]:='';
	txt[3]:='';
        txt[4]:='';
        drawwindow(30,15,4);
        pport:=getname(file1);
     end; {if lpt=4}

end;
{************************************************************************}
procedure hertz;

var
   old:byte;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='       50Hz           ';
txt[2]:='       60Hz           ';
drawwindow(30,15,2);
with receiver[recno]^ do
begin
  old:=line_rej;
  line_rej:=selection(2,line_rej+1,line_rej+1)-1;
  if online and not(escape) then
   begin
   wrtworking;
   set_linerej(recno);
   gotoxy(1,25);
   write('            ');
   if msgerror then
      begin
      line_rej:=old;
      wrterror;
      end;
    end;
  end;
end;
{************************************************************************}
procedure tx_type;

var
   t,old,i:byte;
   x,y:integer;
   key:char;

begin
txt[0]:='   '+screen[scno].cell[xcur,ycur].title;
txt[1]:='       831            ';
txt[2]:='       832            ';
drawwindow(30,15,2);
old:=receiver[recno]^.transmitter[txno].txtype;
with  receiver[recno]^.transmitter[txno] do
   begin
      txtype:=selection(2,txtype,txtype);
   end; {with receiver}
if not(escape) then
   begin
	if online then
	  begin
           wrtworking;
	   set_txtype(recno,txno);
	   gotoxy(1,25);
	   write('            ');
	   { versions of 836 software before v3.1 don't reset parameters}
	   { when txtype changed so after changing txtype read back configuration}
	   if not(msgerror) then
		upload_tx(recno,txno);
	   if msgerror
	     then
		begin
                 wrterror;
                 receiver[recno]^.transmitter[txno].txtype:=old;
		end {if msgerror}
	  end {if online}
	 else {if online else}
	  begin
	       {offline so just initialise data for selected transmitter}
	       init_tx(recno,txno,receiver[recno]^.transmitter[txno].txtype);
	  end; {if online else}

    if (receiver[recno]^.transmitter[txno].txtype=2) and (chno>8) then chno:=1;
    with receiver[recno]^.transmitter[txno] do
    for i:=1 to 16 do
        if (channel[i].input_type in[7..12]) and (txtype=2) then channel[i].input_type:=0;

    end; {if not(escape)}

end;
{************************************************************************}

Procedure initwind;

var
i,j,s:integer;
loadf:text;
dummy:string;
t1:byte;
iocode:integer;

begin
xcur:=1;
ycur:=1;
lpt:=1;
online:=true;

{Load up data into screens}
{$I-}
assign(loadf,'mess838.scn');
reset(loadf);
{$I+}
iocode:=ioresult;
if iocode=0
   then
     begin
        for i:=1 to 100 do
        readln(loadf,message[i]);
        close(loadf);
     end
   else
    begin
        writeln;
        writeln('  ERROR LOADING FILE :- "MESS838.SCN" NOT FOUND');
        halt;
    end;

{$I-}
assign(loadf,'conf838.scn');
reset(loadf);
{$I+}
iocode:=ioresult;
if iocode=0
   then
     begin
       for s:=1 to no_of_screens do
        begin
        with screen[s] do
            begin
            readln(loadf,maxx);
            for i:=1 to maxx do
                readln(loadf,maxy[i]);
            t1:=maxy[i];
            for i:=1 to maxx do
                for j:=1 to maxy[i] do
                    with cell[i,j] do
                         begin
                         readln(loadf,title);
                         readln(loadf,xpos);
                         readln(loadf,ypos);
                         readln(loadf,hstr1);
                         readln(loadf,hstr2);
                         end;
            end;
          end;
        close(loadf);
     end
   else
    begin
        writeln;
        writeln(' ERROR LOADING FILE :- "CONF838.SCN" NOT FOUND');
        halt;
    end;

end;

{*********************************************************************}

procedure reset_rx(recno,rectype:byte);
{created 24/1/92 aps}
{either resets 836 and data base or if offline}
{just resets pcs83 data base to default parameters}

var
x,y:integer;
key:char;

begin
msgerror:=false;

if online
 then
   begin

   send_reset(recno,rectype);

   if (not(msgerror)) then
  	with globdat do
     	begin
	  initrx(recno,rectype);
	  upload;
	  chno:=1;
	  txno:=1;
	  send_confirm(recno);
	end;
   end {if online}
 else
   begin
     x:=25;
     y:=15;
     normal;
     window(x-1,y-1,x+29,y+5);
     clrscr;
     setwindow(x,y,30,6);
     gotoxy(8,1);
     write('OFFLINE RESET');
     gotoxy(3,3);
     write('Database Reset');
     gotoxy(3,4);
     write('Download required if');
     gotoxy(3,5);
     write('receiver is to be reset');
     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
     with globdat do
     	initrx(recno,rectype);
   end; {if online else}

end;
{************************************************************************}
procedure sw301;
{Decode explanation of host comms adaptor sw301 settings}

var temp,x,y:integer;
    key:char;

begin

     x:=15;
     y:=5;
     normal;
     window(x-1,y-1,x+45,y+18);
     clrscr;
     setwindow(x,y,46,19);
     gotoxy(15,1);
     write('HCA SWITCH SW301');
     gotoxy(3,4);
     write('Levers 1 to 4 : Set Comms parameters.');
     gotoxy(3,5);
     write('Lever 5 : Set mode for Link B address.');
     gotoxy(3,6);
     write('Lever 6 : Unused');
     gotoxy(3,7);
     write('Lever 7 : Selects Modbus RTU/ASCII mode.');
     gotoxy(3,8);
     write('Lever 8 : Unused');
     gotoxy(15,10);
     textbackground(blue);
     write(' CURRENT SETTINGS ');
     normal;
     gotoxy(5,12);
     temp:=receiver[recno]^.hcaswitch;
     case (temp and $f) of
          0:write('300 Baud 8bit no parity');
          1:write('1200 Baud 8bit no parity');
          2:write('1200 Baud 8bit odd parity');
          3:write('1200 Baud 8bit even parity');
          4:write('2400 Baud 8bit no parity');
          5:write('9600 Baud 8bit no parity');
          6:write('9600 Baud 8bit odd parity');
          7:write('9600 Baud 8bit even parity');
          8:write('9600 Baud 7bit no parity');
          9:write('9600 Baud 7bit odd parity');
          10:write('9600 Baud 7bit even parity');
          11:write('19200 Baud 8bit no parity');
          12..14:write('ERROR - INVALID COMMS SETTING');
          15:write('Comms Parameters software defined');
          end;
     gotoxy(5,14);
     if (temp and $10)=0 then
                  write('Link B address = Link A address')
                else
                  write('Link B address = Link A address + 32');
     gotoxy(5,16);
     if (temp and $40)=0 then
                  write('RTU Mode')
                  else
                  write('ASCII Mode');

     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end;

{************************************************************************}
procedure sw101;
{Decode explanation of input processor sw101 settings}

var temp,x,y:integer;
    key:char;

begin

     x:=15;
     y:=5;
     normal;
     window(x-1,y-1,x+50,y+18);
     clrscr;
     setwindow(x,y,51,19);
     gotoxy(17,1);
     write('IP SWITCH SW101');
     gotoxy(3,4);
     write('Levers 1 to 5 : Sets Modbus Address.');
     gotoxy(3,5);
     write('Lever 6 : Enables / Disables HAN83 changes.');
     gotoxy(3,6);
     write('Lever 7 : Enables / Disables Serial changes.');
     gotoxy(3,7);
     write('Lever 8 : Factory use only, should be 0.');
     gotoxy(15,9);
     textbackground(blue);
     write(' CURRENT SETTINGS ');
     normal;
     gotoxy(5,11);
     temp:=receiver[recno]^.ipswitch and $1f;
     if temp=0 then
                 write('Modbus Address Software Defined')
               else
                 write('Modbus Address: ',temp);
     gotoxy(5,13);
     temp:=receiver[recno]^.ipswitch;
     if (temp and $20)=0 then
                  write('HAN83 configuration ENABLED')
                else
                  write('HAN83 configuration DISABLED');
     gotoxy(5,15);
     if (temp and $40)=0 then
                  write('Serial configuration ENABLED')
                  else
                  write('Serial configuration DISABLED');
     gotoxy(5,17);
     if (temp and $80)=0 then
                  write('Normal operation')
          else
              begin
                   textbackground(errbar);
                   write('FACTORY TEST SETTING - CHANGE!');
              end;

     normal;
     window(1,1,80,25);
     gotoxy(1,25);
     textbackground(black);
     write('                            ');
     textbackground(errbar);
     write(' Any key to Continue ');
     window(1,1,80,25);
     key:=readkey;
     normal;
     window(1,1,80,25);
end;

{************************************************************************}

function iptypestring(tx_type,input_type:byte):string;
{ function returns a descriptive string for the given input type, this  }
{ also depends on transmitter type, tx_type  }

begin
   if tx_type = 1 then
     begin
	 case input_type of
		   0..14:iptypestring:=iptype831a[input_type+1];
		   16..27:iptypestring:=iptype831b[input_type-15];
		   else iptypestring:='Invalid';
		   end;
     end
     else
       case input_type of
		    0:iptypestring:=iptype832[1];
		    13:iptypestring:=iptype832[2];
		    15:iptypestring:=iptype832[3];
		    else iptypestring:='Invalid';
                    end;
end; {function iptypestring}
end.

